app.controller('adminChatCtrl', function($scope, $interval, $ionicScrollDelegate, $ionicHistory ) {
    var _intervalPromise = {};

    $scope.$on('$ionicView.enter', function() {
        _getMessages();
        _startInterval();
    });

    $scope.Messages = [];
    var _getMessages = function(){
        $scope.ajaxGetPromise('AdminMessageApi/GetConversation', null, true)
            .then(function(response) {
                if(!response.Success) return;
                var oldLength = $scope.Messages.length;
                $scope.Messages = response.Payload.Messages;
                if(oldLength < response.Payload.Messages.length)
                    _scrollBottom();
            })
    }
    
    var _startInterval = function() {
        _intervalPromise = $interval(function() {
            if ('home.adminChat' != $ionicHistory.currentView().stateName)
                $interval.cancel(_intervalPromise);
            else
                _getMessages();
        }, 3000)
    }

    $scope.sendText = function(){
        var msg = {
            Sender: 'User',
            Message: $scope.message,
            Note: $scope.message,
            Sending: true,
            Created: moment().format(),
            Read: null
        };
        $scope.message = '';
        $scope.Messages.push(msg);
        _scrollBottom();

        $scope.ajaxPostPromise('AdminMessageApi/send', msg, true)
            .then(function(response) {
                msg.Sending = false;
                if (!response.Success) {
                    msg.SendingFailed = true;
                    return;
                }
            }, function() {
                msg.Sending = false;
                msg.SendingFailed = true;
            })
    }
    var viewScroll = $ionicScrollDelegate.$getByHandle('userMessageScroll');
    var _scrollBottom = function(target) {
        viewScroll.scrollBottom(true);
    }
})