app.controller('advanceFilterCtrl', function($scope, $filter, listService, $ionicNativeTransitions, $timeout) {
    var _filter = $filter('filter')

    $scope.goToSlider = function(index){
        localStorage.advanceFilterIndex = index;
        $ionicNativeTransitions.stateGo('home.advanceFilterSlider', {}, {}, {
            "type": "slide",
            "direction": "up"
        });
    }

    $scope.$on('$ionicView.enter', function() {
        $timeout(function(){
            _setSelectedFilters();
        },100)
    });

    var _setSelectedFilters = function(){
        if(!localStorage.AdvanceFilters) return;
        var advFilters  = JSON.parse(localStorage.AdvanceFilters);
        for (var property in advFilters) {
            if (advFilters.hasOwnProperty(property)) {
                var item = _filter($scope.AdvanceFiltersList, {QueryPropName : property})[0]
                if(item === undefined) continue;
                item.Selected = true;
                item.Description = '';
                var filters = item.Lookup;
                if(item.IsRadio){
                    item.SelectedValue = advFilters[property];
                    item.Description = _filter(filters, {Value : item.SelectedValue})[0].Description;
                }else{
                    angular.forEach(advFilters[property], function(id){
                        var f = _filter(filters, id)[0];
                        f.IsChecked = true;
                        item.Description += f.Description + ',';
                    })
                    
                }
                item.Description = item.Description.replace(/,([^,]*)$/,'$1');
            }
        }
    }
});