app.controller('advanceFilterSliderCtrl', function($scope, $ionicSlideBoxDelegate, popupService,$timeout,$ionicHistory, $ionicScrollDelegate) {
    $scope.showLoading = true;
    $scope.activeSlide = 0;
    
    popupService.showSwipeMsg($scope);

    $timeout(function() {
        $scope.Slides = $scope.AdvanceFiltersList;
        $timeout(function(){
            $scope.activeSlide = parseInt(localStorage.advanceFilterIndex);
            $ionicSlideBoxDelegate.update();
            $scope.showLoading = false;
        },100)
    }, 300);

    $scope.NextSlide = function(){
        $ionicSlideBoxDelegate.next();
    }

    $scope.slideChanged = function(index){
        $ionicScrollDelegate.$getByHandle('advanceFilterSlider').scrollTop();
        if(isNaN(index)) return;
        $scope.Header = $scope.Slides[index].Header;
    }

    $scope.backToList = function() {
        $scope.goBackDown()
        _updateFilters();
    };

    var _updateFilters = function(){
        var selectedFilters = {};
        angular.forEach($scope.AdvanceFiltersList, function(s){
            if(s.IsRadio && s.SelectedValue !== undefined){
                selectedFilters[s.QueryPropName] = s.SelectedValue;
                s.Selected = true;
            }else{
                var filter = s.Lookup;
                var selectedIds = [];
                var description = [];
                var found = false;
                angular.forEach(filter, function(item){
                    if(item.IsChecked){
                        selectedIds.push(item.Value)
                        description += item.Description + ','
                        found = true;
                    }
                })
                s.Selected = found;
                if(found){
                    selectedFilters[s.QueryPropName] = selectedIds;
                    s.Description = description.replace(/,([^,]*)$/,'$1');
                }                
            }
        })
        localStorage['AdvanceFilters'] = JSON.stringify(selectedFilters);
    }
});