app.controller('exploreCtrl', function($scope, $ionicModal, $filter, $stateParams, $timeout, $state, $ionicNativeTransitions, pushNotificationService,$ionicHistory,$interval) {
    var cards,_profiles, firstTime, _profileIds, _getCheckedItems;
    $scope.UnreadMessagesCount = 0;

    cards = [];
    _profiles = [];
    firstTime = true;
    _profileIds = [];
    _getCheckedItems = $filter('CheckedItemFilter');
    
    var _loadModal
    $scope.cards = [];
    $scope.Message = "Loading..."
    $scope.loading = false;
    $timeout(function(){
        var stateName = $ionicHistory.currentView().stateName
        if (stateName.indexOf('home') !== -1
                && stateName.indexOf('home.deletedProfile') === -1)
            $scope.checkPushNotification();
    },20000)

    $interval(function(){
        var stateName = $ionicHistory.currentView().stateName
        if (stateName.indexOf('home.explore') === -1)
            return;
        $scope.ajaxGetPromise('MessagingApi/UnreadMessagesCount', null, true)
            .then(function(response){
                if(!response.Success) return;
                $scope.UnreadMessagesCount = response.Payload
            })
    }, 3000);

    $scope.$on('$ionicView.enter', function() {
        if(firstTime || localStorage.applyFilters === 'true'){
            _onLoad();
            localStorage.applyFilters = false;
            return;
        }else if($scope.changeCard && $scope.cards.length > 0){
            $scope.cards.splice(0,1);
            $scope.$parent.changeCard = false;
        }
    });

    var _onLoad = function(){
        $scope.cards = [];
        _profileIds = [];
        $scope.loading = true;
        $scope.ajaxPostPromise('SearchApi/Query', _getSearchFilters(), true)
            .then(function(response){
              $scope.loading = false;
              if(!response.Success){
                $scope.Message = "Something went wrong!"
                return;
              }
              firstTime = false;
              if(response.Payload.Results.length == 0){
                $scope.Message = "No matches found."
                return;
              }
              _createProfileIdsArray(response.Payload.Results);
              _getProfileList(_profileIds.splice(0,10))
            })
    }

    /* Helper functions*/
        var _getSearchFilters = function(){
            var basicSearchFilters = {
                MaxAge : $scope.PreviousSearch.ageTo,
                MinAge : $scope.PreviousSearch.ageFrom,
                OnlineSince : $scope.PreviousSearch.onlineSince,
                CountryList : _getCheckedItems($scope.PreviousSearch.SelectedCountries),
                DenominationList : _getCheckedItems($scope.PreviousSearch.SelectedDenominations),
                MaritalStatusList : _getCheckedItems($scope.PreviousSearch.SelectedMaritalStatuses),
                ExcludeLikedProfiles : true
          };
          
          if(!localStorage['AdvanceFilters']) return basicSearchFilters;
          var AdvanceFilters = JSON.parse(localStorage.AdvanceFilters);
          return _mergeOptions(AdvanceFilters, basicSearchFilters);
        }
        /**
         * Overwrites obj1's values with obj2's and adds obj2's if non existent in obj1
         * @param obj1
         * @param obj2
         * @returns obj3 a new object based on obj1 and obj2
         */
        var _mergeOptions = function(obj1,obj2){
            var obj3 = {};
            for (var attrname in obj1) { obj3[attrname] = obj1[attrname]; }
            for (var attrname in obj2) { obj3[attrname] = obj2[attrname]; }
            return obj3;
        }

        var _createProfileIdsArray = function(profileList){
            _profiles = profileList;
            var profiles = [];
            angular.forEach(profileList, function(p){
                profiles.push(p.ProfileId);
            })
            _profileIds = profiles;
        }
    /* Helper functions end*/

    var _getProfileList = function(ids){
        $scope.Message = "Loading..."
        $scope.loading = true;
        $scope.ajaxGetPromise('SearchApi/GetProfiles', { ids : ids }, true).then(function(response){
            $scope.loading = false;
            if(!response.Success){
                $scope.Message = 'Something went wrong.';
                return;
            }
            $scope.Message = '';
            cards = response.Payload;
            _setMatchPercentage(_profiles);
            _addCards(2);
        })
    }
    
    var _setMatchPercentage = function(allProfiles){
        cards.forEach(function(cProfile){
            var selected = allProfiles.find(function(p){
                        return (p.ProfileId == cProfile.ProfileId)
                    })
            if(selected)
                cProfile.Match = (selected.Per1 * 100);
        })
    }

    function _addCards(quantity) {
      for (var i = 0; i < Math.min(cards.length, quantity); i++) {
        $scope.cards.push(cards[0]);
        cards.splice(0, 1);
      }
    }

    var _firstLoad = true;
    $scope.$watch('cards.length', function(newVal, oldVal){
        if(newVal === 0){
            if(_profileIds.length > 0){
                $scope.Message = "Loading...";
                _getProfileList(_profileIds.splice(0,10))
            }else if (oldVal != 0){
                $scope.Message = "End reached";
            }else{
                $scope.Message = "No matches found";
                if(_firstLoad){
                    $scope.Message = "Loading...";
                    _firstLoad = false;
                }
            }
        }
    })
    $scope.LastProfile;
    /*card callback functinos*/
        $scope.cardDestroyed = function(index, action) {
            var profile = $scope.cards.splice(index, 1)[0];
            $scope.LastProfile = profile;
            _addCards(1);
            if(action != undefined){
                $scope.isMoveRight = action === 'Liked';
                $scope.isMoveLeft = action === 'Hide';
            }
    
            if(profile.TargetMarketOwnerAsFavorite && $scope.isMoveRight)
                _mutualLikedModal.show();

            _updateNetwork(profile, $scope.isMoveRight, $scope.isMoveLeft)
            $scope.isMoveLeft = false;
            $scope.isMoveRight = false;
        };

        var _updateNetwork = function(profile, IsFavorite, IsBlocked){
            var request = {
                TargetProfileId : profile.ProfileId,
                TargetUsername : profile.Username,
                IsFavorite : IsFavorite,
                IsBlocked : IsBlocked
            }
            var promise = $scope.ajaxPostPromise('NetworkApi/UpdateNetwork', request, true);
                promise.then(function(response){
                    if(!response.Success) 
                        return;
                })
        }
        $scope.cardSwiped = function(index) {
          $scope.cards.push(cards[Math.floor(Math.random(1)*8)]);
        };

        // For reasons, the cardSwipedRight and cardSwipedLeft events don’t get called always
        // https://devdactic.com/optimize-tinder-cards/
        $scope.cardSwipedLeft = function(event, index) {
            $scope.isMoveLeft = true;
          event.stopPropagation();
        }

        $scope.cardSwipedRight = function(event, index) {
          $scope.isMoveRight = true;
          event.stopPropagation();

          // Open Match popup
          //if (cards.length % 3 == 1) $scope.openMatchModal();
        }

        $scope.cardPartialSwipe = function(amt) {
          $scope.isMoveLeft = amt < -0.15;
          $scope.isMoveRight = amt > 0.15;
        }
    /*card callback functinos end*/

    /* filters popup*/
        var _mutualLikedModal;
        $timeout(function(){ _loadModal(); }, 500);
        var _loadModal = function(){
            $ionicModal.fromTemplateUrl('templates/modals/mutualLikedModal.html', {
              scope: $scope,
              animation: 'slide-in-up'
            }).then(function(modal) {
              _mutualLikedModal = modal;
            });            
        }

        $scope.closeMatchModal = function() {
          _mutualLikedModal.hide();
        };

    /* filters popup*/
    $scope.gotoChat = function(profile){
        if($scope.cards.length == 0) return;
        $scope.closeMatchModal();
        var data = {
            User : { 
                ProfileId : profile.ProfileId, 
                Username : profile.Username,
                CoverImage : profile.ImagePath,
                IsOnline : profile.IsOnline,
                IsBlocked : profile.IsBlocked,
                SharePrivateImage : profile.SharePrivateImage
            },
            ProfileId : profile.ProfileId
        };
        $ionicNativeTransitions.stateGo('home.chat', data, {}, {
            "type": "slide",
            "direction": "up", // 'left|right|up|down', default 'left' (which is like 'next')
            "duration": 400, // in milliseconds (ms), default 400
        });
    }
  })