app.controller('profileCtrl', function($scope, $ionicModal, $stateParams, $ionicNativeTransitions, $ionicSlideBoxDelegate, $timeout, $ionicActionSheet, $state,$ionicHistory, $ionicPopup, $filter) {
    $scope.UserInfo = {
        Images: [],
        Details: {},
        ShortDetails: {}
    };

    $scope.$on('$stateChangeStart', function(){
      $scope.lockFeatureModal.remove();
    });

    var _showTutorialPopup = function(){
        if(!localStorage['profileMsgShown']){
            $ionicPopup.confirm({
                title: 'Profile',
                template: '<figure class="profileDetT"></figure><br/><span class="textCenBlk">click on profile image once to close profile details</span>',
                buttons: [{
                    text: 'Don\'t show again',
                    onTap: function(e) {
                            localStorage['profileMsgShown'] = true;
                        }
                    },{
                      text: '<b>Okay</b>',
                      type: 'button-positive'
                    }
                  ]
            })
        }        
    }

    $scope.IsHiding = false;

    $scope.LoginHistoryShowHide = false;
    $scope.LoginHistoryShowHideList = function(){
        if($scope.LoginHistoryShowHide){
            $scope.LoginHistoryShowHide = false;
        }else{
            $scope.LoginHistoryShowHide = true;
        }
    }
    $scope.ProfileViewShowHide = false;
    $scope.ProfileViewShowHideList = function(){
        if($scope.ProfileViewShowHide){
            $scope.ProfileViewShowHide = false;
        }else{
            $scope.ProfileViewShowHide = true;
        }
    }

    var _profileId;
    var reportModal, _lockFeatureModal; 
    $scope.sharedWithModal = {};
    $scope.extendedDetailsModal = {};
    $scope.showExtendedDetails = function(){
        if($scope.CurrentUser.ShortDetails.IsPaid)
            $scope.extendedDetailsModal.show();
        else
            $scope.lockFeatureModal.show();
    }
    $scope.Images = [''];
    $scope.$on('$ionicView.enter', function() {
        _loadData();
        _goBackClicked = false;
    })

    var _loadData = function() {
        if ($stateParams.ProfileId == _profileId)
            return;
        _profileId = $stateParams.ProfileId;
        _getUserInfo();
    }
    $scope.HideImages = false;
    
    var _getUserInfo = function() {
        $scope.ajaxGetPromise('UsersApi/GetProfile', {
            Id: _profileId
        }) 
        .then(function(response) {
            if (!response.Success) return;
            $scope.UserInfo.ShortDetails = response.Payload.Details.ReadOnlyViewModel.OverviewModel;
            $scope.UserInfo.ReadOnlyViewModel = response.Payload.Details.ReadOnlyViewModel;
            $scope.UserInfo.Questions = response.Payload.Details.ReadOnlyViewModel.QuestionsModel.Questions;
            $scope.UserInfo.Details = response.Payload.Details.ReadOnlyViewModel.DetailsModel;
            $scope.Interests = response.Payload.Details.ReadOnlyViewModel.Interests;
            $scope.Details = response.Payload.Details;
            _setVisibility();
            if(response.Payload.ImagesResponse.Images.length > 0)
                $scope.Images = response.Payload.ImagesResponse.Images;
            $scope.HideImages = response.Payload.ImagesResponse.HideImages;

            $scope.SharedWith = $filter('filter')(response.Payload.SharedWith, {HasRequestorAnswered : true}, true);
            $scope.ExtendedDetails = response.Payload.ExtendedDetailsResponse;
            $timeout(function() {
                $ionicSlideBoxDelegate.update()
            }, 100)
            _showTutorialPopup();
        })
    }

    var _updateNetwork = function(isFavorite) {
        $scope.$parent.changeCard = true;
        var request = {
            TargetProfileId: _profileId,
            TargetUsername: $scope.UserInfo.ShortDetails.Username,
            IsFavorite: isFavorite == true,
            IsBlocked: isFavorite == false
        }
        $scope.Details.IsFavorite = request.IsFavorite;
        $scope.Details.IsHidden = request.IsBlocked;

        var promise = $scope.ajaxPostPromise('NetworkApi/UpdateNetwork', request, true);
        promise.then(function(response) {
            if (!response.Success)
                return;
        })
    }

    $scope.updateNetwork = function(value){
        _updateNetwork(value);
        $scope.IsFavorite = value;
        $scope.IsHiding = $scope.IsFavorite? false : true;
    }

    /*Modals start*/
    var _loadModal = function() {
        $ionicModal.fromTemplateUrl('templates/modals/reportModal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            reportModal = modal;
        });

        $ionicModal.fromTemplateUrl('templates/home/extendedDetailsModal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.extendedDetailsModal = modal;
        });

        $ionicModal.fromTemplateUrl('templates/home/sharedWithModal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.sharedWithModal = modal;
        });
    }
    
    $ionicModal.fromTemplateUrl('templates/modals/extendedLockModal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.lockFeatureModal = modal;
        });

    $timeout(function() {
        _loadModal();
    }, 500);

    $scope.closeModal = function(n) {
        if (n == 'shareWith') {
            $scope.sharedWithModal.hide();
        } else if (n == 'extendedDetails') {
            $scope.extendedDetailsModal.hide();
        } else if (n == 'reportModal') {
            reportModal.hide();
        }
    }
    $scope.openReportModal = function(index) {
            reportModal.show();
    }
    /*Modals end*/

    /*user report start*/
    $scope.Report = {};
    $scope.ReportCompleted = false;

    $scope.SendReport = function() {
        $scope.Report.ProfileId = _profileId;
        $scope.Report.ReportType = 1;
        var promise = $scope.ajaxPostPromise('ReportApi/ReportUser', $scope.Report);
        promise.then(function(response) {
            if (!response.Success)
                return;
            $scope.ReportCompleted = true;
        })
    }

    /*user report end*/
     $scope.goToChat = function(){
        var data = {
            User : { 
                ProfileId : $scope.UserInfo.ReadOnlyViewModel.ProfileId, 
                Username : $scope.UserInfo.ReadOnlyViewModel.OverviewModel.Username,
                CoverImage : $scope.UserInfo.ReadOnlyViewModel.OverviewModel.CoverImage,
                IsOnline : $scope.UserInfo.ReadOnlyViewModel.IsOnline,
                SharePrivateImage : $scope.Details.SharePrivateImage
            },
            ProfileId : $scope.UserInfo.ReadOnlyViewModel.ProfileId
        };

        $ionicNativeTransitions.stateGo('home.chat', data, {}, {
            "type": "slide",
            "direction": "up"
        });
    }
    
    var _goBackClicked = false;
    
    $scope.goBack = function(){
        if(!_goBackClicked){
            $scope.goBackDown();
            _goBackClicked = true;
        }
    }

    $scope.back = function() {
        $ionicNativeTransitions.stateGo($scope.previousState, {}, {}, {
            "type": "slide",
            "direction": "down"
        });
    }

    /*action sheet start*/
    var hideSheet;
    $scope.showUserOptions = function() {
            var actionBtns = [{
                text: '<i class="icon androidOnly ion-ios-chatbubble-outline"></i> Message',
                Action: function() {
                    $scope.goToChat();
                }
            }, {
                text: '<i class="icon androidOnly ion-person-stalker"></i> Two of Us',
                Action: function() {
                    $scope.sharedWithModal.show();
                    hideSheet();
                }
            }, {
                text: '<i class="icon androidOnly ion-ios-paper-outline"></i> Extended Details',
                Action: function() {
                    $scope.showExtendedDetails();
                    hideSheet();
                }
            }, {
                text: '<i class="icon androidOnly ion-ios-information-outline"></i> Report',
                Action: function() {
                    $scope.openReportModal();
                    hideSheet();
                }
            }];
            
            var networkTxt = $scope.Details.IsFavorite ? '<i class="icon androidOnly ion-ios-close-outline"></i> Hide' : '<i class="icon androidOnly ion-ios-heart-outline"></i> Like';
            actionBtns.unshift({
                text: networkTxt,
                Action: function() {
                    _updateNetwork(!$scope.Details.IsFavorite);
                    hideSheet();
                }})

            hideSheet = $ionicActionSheet.show({
                buttons: actionBtns,
                cancelText: '<i class="icon androidOnly ion-ios-arrow-down"></i> Cancel',
                cancel: function() {
                    // add cancel code..
                },
                buttonClicked: function(index) {
                    actionBtns[index].Action();
                }
            });
        }

    /*action sheet end*/

    var _setVisibility = function(){
        var d = $scope.UserInfo.Details;
        $scope.isVisualAppearanceVisible = ((d.Height != null && d.Height.length > 0)
            || (d.BodyType != null && d.BodyType.length > 0)
            || (d.Complextion != null && d.Complextion.length > 0)
            || (d.EyeColor != null && d.EyeColor.length > 0)
            || (d.HairColor != null && d.HairColor.length > 0)
            || (d.Hijab != null && d.Hijab.length > 0))

        $scope.isCulturalBackgroundVisible = ((d.Ethnicity != null && d.Ethnicity.length > 0)
                    || (d.BirthCountry != null && d.BirthCountry.length > 0)
                    || (d.PrimaryLanguage != null && d.PrimaryLanguage.length > 0)
                    || (d.SecondaryLanguage != null && d.SecondaryLanguage.length > 0)
                    || (d.TertiaryLanguage != null && d.TertiaryLanguage.length > 0))

        $scope.isFamilyVisible = ((d.FatherStatus != null && d.FatherStatus.length > 0)
                || (d.MotherStatus != null && d.MotherStatus.length > 0)
                || (d.BrotherCount != null && d.BrotherCount.length > 0)
                || (d.SisterCount != null && d.SisterCount.length > 0))

        $scope.isEducationCareerVisible = ((d.EducationLevel != null && d.EducationLevel.length > 0)
                || (d.EducationMajor != null && d.EducationMajor.length > 0)
                || (d.AnnualIncome != null && d.AnnualIncome.length > 0)
                || (d.WorkType != null && d.WorkType.length > 0)
                || (d.Career != null && d.Career.length > 0)
                || (d.PartnerWorkStatus != null && d.PartnerWorkStatus.length > 0))

        $scope.isLifestyleVisible =
             ((d.Diet != null && d.Diet.length > 0)
                || (d.DietFrequency != null && d.DietFrequency.length > 0)
                || (d.Drinks != null && d.Drinks.length > 0)
                || (d.Smokes != null && d.Smokes.length > 0)
                || (d.Drugs != null && d.Drugs.length > 0))

        $scope.isAdditionalQuestionsVisible = ((d.BloodType != null && d.BloodType.length > 0)
                || (d.SpecialCase != null && d.SpecialCase.length > 0))
    }
});