app.controller('searchFilterCtrl', function($scope,$filter, $ionicNativeTransitions) {    
    var _filter = $filter('filter');

    $scope.$on('$ionicView.enter', function() {
        localStorage.applyFilters = true;
    });

    $scope.arrayJoin = function(arr) {
        str = '';      
        angular.forEach(_filter(arr, {IsChecked:true}), function(i){
            str += i.Description + ', ';
        })
        return str.replace(/,([^,]*)$/,'$1');
    }
    
    $scope.goSlider = function(index){
        $ionicNativeTransitions.stateGo('home.basicFilterSlider', {Index : index}, {}, {
            "type": "slide",
            "direction": "up"
        });
    }

    $scope.Slides = [{
        Header: 'Age',
        ModelPropertyName: 'ageFrom',
        SubModelPropertyName: 'ageTo',
        hasAge: true
    }, {
        Header: 'Location',
        LookupPropertyName: 'SelectedCountries',
    }, {
        Header: 'Marital Status',
        LookupPropertyName: 'SelectedMaritalStatuses',
    }, {
        Header: 'Denomination',
        LookupPropertyName: 'SelectedDenominations',
    }, {
        Header: 'Last Online',
        LookupPropertyName: 'OnlineSinceOptions',
        ModelPropertyName : 'onlineSince',
        Last: true,
        IsRadioType : true
    }];

    $scope.reset = function(){
        _uncheckItems($scope.PreviousSearch.SelectedDenominations)
        _uncheckItems($scope.PreviousSearch.SelectedCountries)
        _uncheckItems($scope.PreviousSearch.SelectedMaritalStatuses)
        $scope.PreviousSearch.onlineSince = 'In_Last_Month';
        $scope.PreviousSearch.ageTo = 45;
        $scope.PreviousSearch.ageFrom = 18;

        if(!localStorage.AdvanceFilters) return;
        var advFilters  = JSON.parse(localStorage.AdvanceFilters);
        for (var property in advFilters) {
            if (advFilters.hasOwnProperty(property)) {
                var item = _filter($scope.AdvanceFiltersList, {QueryPropName : property})[0]
                if(item === undefined) continue;
                item.Selected = true;
                item.Description = '';
                var filters = item.Lookup;
                if(item.IsRadio){
                    item.SelectedValue = null;
                }else{
                    angular.forEach(advFilters[property], function(id){
                        var f = _filter(filters, id)[0];
                        f.IsChecked = false;
                    })
                    
                }
            }
        }
        localStorage.removeItem('AdvanceFilters');
    }
    var _uncheckItems = function(arr){
        angular.forEach(arr, function(i){
            i.IsChecked = false;
        })
    }
});