app.controller('matchesCtrl', function($scope, $ionicModal, $ionicSlideBoxDelegate, $ionicPopup, $state, popupService, $filter, $ionicNativeTransitions,$ionicScrollDelegate) {
    var _filter = $filter('filter');
    var _declinedConversations = [];
    $scope.activeNetworkTab = 'MutualLike';
    $scope.Networks = [];
    $scope.loading = false;

    var _mySelection = [];
    var _likedMe = [];
    var _mutualLikes = [];
    var _hiddenProfiles = [];
    var _data = [];
    var _profileToShow = 25;
    var _firstLoad = true;

    $scope.$on('$ionicView.enter', function() {
        var previousState = $scope.previousState.name;
        if(previousState == 'home.profile')
            return;

        _getNetwork();
        if(_firstLoad)
            _firstLoad = false;
    });

   

    var _getNetwork = function() {
        $scope.loading = !_firstLoad;
        $scope.ajaxGetPromise('NetworkApi/get', null, !_firstLoad)
            .then(function(data) {
                _data = data.Payload;
                var initialLoadCount = 15;
                $scope.Networks = {
                    LikedProfiles : _data.LikedProfiles.splice(0, Math.min(initialLoadCount, _data.LikedProfiles.length)),
                    MutualLikedProfiles : _data.MutualLikedProfiles.splice(0, Math.min(initialLoadCount, _data.MutualLikedProfiles.length)),
                    LikedMeProfiles : _data.LikedMeProfiles.splice(0, Math.min(initialLoadCount, _data.LikedMeProfiles.length)),
                    HiddenProfiles : _data.HiddenProfiles.splice(0, Math.min(initialLoadCount, _data.HiddenProfiles.length))
                }

                $scope.Conversations = {
                    MutualLiked : data.Payload.MutualLikedProfileConversations,
                    LikedMe : data.Payload.LikedMeProfileConversations,
                    Liked : data.Payload.LikedProfileConversations,
                }
                $scope.loading = false;
                _updateShowMore(false);
            })
    }

    $scope.UpdateTab = function(tab) {
        $scope.activeNetworkTab = tab;
    }

    $scope.loadMore = function(){
        switch($scope.activeNetworkTab){
            case 'MySelection':
                $scope.Networks.LikedProfiles = $scope.Networks.LikedProfiles.concat(_data.LikedProfiles.splice(0, Math.min(_profileToShow, _data.LikedProfiles.length)));
                break;
            case 'MutualLike':
                $scope.Networks.MutualLikedProfiles = $scope.Networks.MutualLikedProfiles.concat(_data.MutualLikedProfiles.splice(0, Math.min(_profileToShow, _data.MutualLikedProfiles.length)));
                break;
            case 'LikedMe':
                $scope.Networks.LikedMeProfiles = $scope.Networks.LikedMeProfiles.concat(_data.LikedMeProfiles.splice(0, Math.min(_profileToShow, _data.LikedMeProfiles.length)));
                break;
            case 'Hidden':
                $scope.Networks.HiddenProfiles = $scope.Networks.HiddenProfiles.concat(_data.HiddenProfiles.splice(0, Math.min(_profileToShow, _data.HiddenProfiles.length)));
                break;
            default:
                break;
        }
        _updateShowMore(false);
    }

    $scope.$watch('activeNetworkTab', function(newVal, oldVal){
        if(newVal == oldVal) return;
        _updateShowMore(true);
    })

    var _updateShowMore = function(scrollToTop){
        $scope.ShowHiddenIcon = false;
        $scope.IsLiked = false;
        $scope.showMore = false;
        switch($scope.activeNetworkTab){
            case 'MySelection':
                $scope.showMore = (_data.LikedProfiles.length > 0)
                $scope.hasConversation = ($scope.Networks.LikedProfiles.length != 0)
                $scope.hasNewConversation = ($filter('filter')($scope.Conversations.Liked , {Status : 'New'}).length > 0)
                $scope.MutualLikeHearts = false;
                $scope.IsLiked = true;
                break;
            case 'MutualLike':
                $scope.showMore = (_data.MutualLikedProfiles.length > 0)
                $scope.hasConversation = ($scope.Networks.MutualLikedProfiles.length != 0)
                $scope.hasNewConversation = ($filter('filter')($scope.Conversations.MutualLiked , {Status : 'New'}).length > 0)
                $scope.MutualLikeHearts = true;
                $scope.IsLiked = false;
                break;
            case 'LikedMe':
                $scope.showMore = (_data.LikedMeProfiles.length > 0)
                $scope.hasConversation = ($scope.Networks.LikedMeProfiles.length != 0)
                $scope.hasNewConversation = ($filter('filter')($scope.Conversations.LikedMe , {Status : 'New'}).length > 0)
                $scope.MutualLikeHearts = false;
                $scope.IsLiked = false;
                break;
            case 'Declined':
                $scope.ShowHiddenIcon = true;
                $scope.showMore = false;
                $scope.hasConversation = ($scope.Networks.HiddenProfiles.length != 0)
                $scope.declinedConversations = _data.DeclinedConversations;
                break;
            case 'Hidden':
                $scope.ShowHiddenIcon = true;
                $scope.hasConversation = ($scope.Networks.HiddenProfiles.length != 0)
                $scope.showMoreHidden = (_data.HiddenProfiles.length > 0);
                break;      
            default:
                $scope.showMore = false;
                break;
        }

        if(scrollToTop){
            $ionicScrollDelegate.$getByHandle('horizontalScroll').scrollTop();
            $ionicScrollDelegate.$getByHandle('contentScroll').scrollTop();
        }else{
            $ionicScrollDelegate.$getByHandle('horizontalScroll').resize();
            $ionicScrollDelegate.$getByHandle('contentScroll').resize();
        }
    }
    
    $scope.goToProfile = function(item){
        //if($scope.activeNetworkTab == 'LikedMe' )
        if($scope.activeNetworkTab == 'LikedMe' && !($scope.CurrentUser.IsPaid)){
            $ionicPopup.confirm({
                title: 'Premium Feature',
                template: '<figure class="paidFetLock"></figure><br/><span class="textCenBlk"><h1 class="text-20">This Feature Is Locked</h1> only premium members can view profile details of who "liked me"</span>',
                buttons: [{
                      text: '<b>Okay</b>',
                      
                    },{
                    text: 'Get Access Key',
					type: 'pinkButtonPop',
                    onTap: function(e) {
                            $scope.goToPayment();
                        }
                    }
                  ]
            })
        }else{
            $ionicNativeTransitions.stateGo('home.profile', {ProfileId : item.TargetProfileId}, {}, {
            "type": "slide",
            "direction": "up", // 'left|right|up|down', default 'left' (which is like 'next')
            "duration": 400, // in milliseconds (ms), default 400
            });
        }
    }

    $scope.hasConversation = true;
    $scope.goToChat = function(item){
        var data = {
            User : { 
                ProfileId : item.WithProfileId,
                Username : item.WithUsername,
                CoverImage : item.WithProfileImage,
                IsOnline : item.TargetIsOnline,
                IsBlocked : item.IsBlocked,
                SharePrivateImage : item.SharePrivateImage
            },
            ProfileId : item.WithProfileId
        };
        $ionicNativeTransitions.stateGo('home.chat', data, {}, {
            "type": "slide",
            "direction": "up", // 'left|right|up|down', default 'left' (which is like 'next')
            "duration": 400, // in milliseconds (ms), default 400
        });
        console.log(item);
    }
})