app.controller('chatCtrl', function($scope, $stateParams, $ionicModal, $ionicScrollDelegate, $interval, $ionicHistory, $timeout, $ionicActionSheet, $state, $ionicNativeTransitions) {
    var _profileId;
    $scope.Messages = [];
    $scope.LoadingMore = false;
    $scope.HasMoreMessages = false;
    var _paymentPageUrl = "href='#/home/paymentPlan'";

    /* NOTE: 
        uncomment facebook-init script in index.html if in development
        to avoid device undefined error
     */
     
    if(device !== undefined){
        if (device.platform.toLowerCase() == 'ios'){
            _paymentPageUrl = "href='#/home/iosPaymentPage'";
        }
    }

    $scope.$on('$stateChangeStart', function(){
      $scope.lockFeatureModal.remove();
    });

    var _lastMsgId = 0; // last message received from target profile
    var _request = {};
    var _intervalPromise = {};
    var _messagesPerRequest = 20;
    var _pageNo = 1;
    var _totalMessageCount = 0;

    $scope.$on('$ionicView.enter', function() {
        $scope.User = $stateParams.User;
        //do not load if has previously loaded messages
        if (_profileId === $scope.User.ProfileId) {
            _startInterval();
            return;
        }

        _profileId = $stateParams.User.ProfileId;
        $scope.OwnerClass = $scope.CurrentUser.ShortDetails.Gender == 'M' ? 'bgMaleClr' : 'bgFemaleClr';
        $scope.FriendClass = $scope.CurrentUser.ShortDetails.Gender == 'M' ? 'bgFemaleClr' : 'bgMaleClr';
        _request = {
            TargetProfileId: _profileId,
            NumberOfMessagesToReturn: _messagesPerRequest,
        }
        _getMessages();
    });

    $scope.showLockFeatureModel = function() {

    }

    /* filters popup*/
    var _lockFeatureModal, reportModal;
    $timeout(function() {
        _loadModal();
    }, 500);
    var _loadModal = function() {
        $ionicModal.fromTemplateUrl('templates/modals/reportModal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            reportModal = modal;
        });
    }

    $scope.closeModal = function(n) {
        reportModal.hide();
    }

    $scope.openReportModal = function(index) {
        reportModal.show();
    }
    $scope.Report = {};
    $scope.ReportCompleted = false;

    $scope.SendReport = function() {
        $scope.Report.ProfileId = _profileId;
        $scope.Report.ReportType = 1;
        var promise = $scope.ajaxPostPromise('ReportApi/ReportUser', $scope.Report);
        promise.then(function(response) {
            if (!response.Success)
                return;
            $scope.ReportCompleted = true;
        })
    }

    /* Modals Start*/
    $ionicModal.fromTemplateUrl('templates/modals/chatLockModal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.lockFeatureModal = modal;
        });

    /*Update network */
    var _updateNetwork = function(IsFavorite) {
        var request = {
            TargetProfileId: $scope.User.ProfileId,
            IsFavorite: IsFavorite,
            IsBlocked: !IsFavorite
        }
        
        var promise = $scope.ajaxPostPromise('NetworkApi/UpdateNetwork', request);
        promise.then(function(response) {
            if (!response.Success)
                return;
            $scope.User.IsBlocked = !IsFavorite;
        })
    }

    /*load more messages*/
    $scope.LoadMore = function() {
        $scope.LoadingMore = true;
        _pageNo++;
        _request.PageNo = _pageNo;
        _request.MessageCount = _messagesPerRequest;
        $scope.HasMoreMessages = (_totalMessageCount > _messagesPerRequest * _pageNo);
        $scope.ajaxGetPromise('MessagingApi/GetConversation', _request, true)
            .then(function(response) {
                $scope.LoadingMore = false;
                if (!response.Success) return;
                //$ionicScrollDelegate.$getByHandle('userMessageScroll').freezeScroll(true);
                $scope.Messages = response.Payload.Messages.concat($scope.Messages);
                var moveToMessage = response.Payload.Messages.length + 1;
            }, function(err) {
                $scope.LoadingMore = false;
            })
    }

    /*get last _messagesPerRequest messages*/
    var _getMessages = function() {
        var request = angular.copy(_request)
        request.OrderByAsc = true;
        $scope.ajaxGetPromise('MessagingApi/GetConversation', request)
            .then(function(response) {
                _updateFeatureLink(response.Payload.Messages);
                $scope.Messages = response.Payload.Messages;
                _totalMessageCount = response.Payload.TotalMessageCount;
                $scope.HasMoreMessages = (_totalMessageCount > _messagesPerRequest * _pageNo);
                _lastMsgId = _getLastMsgId($scope.Messages);
                _startInterval();
                _scrollBottom();
            })
    }

    /*returns last message id from target profile*/
    var _getLastMsgId = function(msgs) {
        var targetMsgs = [];
        angular.forEach(msgs, function(m) {
            if (!m.IsFromOwner)
                targetMsgs.push(m);
        })
        return (targetMsgs.length == 0) ? 0 : targetMsgs[targetMsgs.length - 1].Id;
    }

    var _updateFeatureLink = function(msgs) {
        angular.forEach(msgs, function(msg) {
            msg.Note = msg.Note.replace("href='#feature_lock'", "href='#/home/premiumFeatures'");
        })
    }

    var _startInterval = function() {
        _intervalPromise = $interval(function() {
            if ('home.chat' != $ionicHistory.currentView().stateName)
                $interval.cancel(_intervalPromise);
            else
                _getNewMessages();
        }, 3000)
    }

    var _getNewMessages = function() {
        var request = angular.copy(_request);
        request.LastMessageId = _getLastMsgId($scope.Messages)
        $scope.ajaxGetPromise('MessagingApi/GetNew', request, true)
            .then(function(response) {
                _updateFeatureLink(response.Payload.Messages);
                angular.forEach(response.Payload.Messages, function(m) {
                    $scope.Messages.push(m)
                })
                if (response.Payload.Messages != null && response.Payload.Messages.length != 0) {
                    _scrollBottom();
                }
            })
    }

    var _sharePrivateImages = function(share){
        var data = {
            SharePrivateImages : share,
            TargetProfileId : $scope.User.ProfileId
        }
        $scope.ajaxPostPromise('NetworkApi/SharePrivateImages', data)
            .then(function(response){
                if(!response.Success)
                    return;
                $scope.User.SharePrivateImage = share;
            })
    }
    $scope.message = '';
    $scope.sendText = function() {
        if ($scope.message.length == 0) return;
        var msg = {
            IsFromOwner: true,
            TargetProfileId: _profileId,
            Note: $scope.message,
            Sending: true,
            Sent: moment().format(),
            Read: null
        };
        $scope.Messages.push(msg);
        $scope.ajaxPostPromise('MessagingApi/send', msg, true)
            .then(function(response) {
                msg.Sending = false;
                if (!response.Success) {
                    msg.SendingFailed = true;
                    return;
                }
            }, function() {
                msg.Sending = false;
                msg.SendingFailed = true;
            })
        $scope.message = '';
        _scrollBottom();
    }

    var viewScroll = $ionicScrollDelegate.$getByHandle('userMessageScroll');
    var _scrollBottom = function(target) {
        viewScroll.scrollBottom(true);
    }


    /*action sheet start*/

    var hideSheet;

    var actionBtns = [{
        text: '<i class="icon androidOnly ion-ios-close-outline"></i> Hide Profile',
        Action: function() {
            hideSheet();
            var request = {
                TargetProfileId: _profileId,
                TargetUsername: $scope.User.Username,
                IsFavorite: false,
                IsBlocked: true
            }
            var promise = $scope.ajaxPostPromise('NetworkApi/UpdateNetwork', request);
            promise.then(function(response) {
                if (!response.Success)
                    return;
                $scope.goBackDown();
            })
        }
    }, {
        text: '<i class="icon androidOnly ion-ios-information-outline"></i> Report',
        Action: function() {
            hideSheet();
            reportModal.show();
        }
    }];
    
    $scope.goToProfile = function(){
        $ionicNativeTransitions.stateGo('home.profile', {
            ProfileId: _profileId
        }, {}, {
            "type": "slide",
            "direction": "up"
        });
    }

    $scope.showUserOptions = function() {
            var btns = [];
            if (!$scope.CurrentUser.ShortDetails.IsPaid) {
                btns.push({
                    text: '<i class="icon androidOnly red_action_btn ion-key"></i> <span class="red_action_btn">Get Access key</span>',
                    Action: function() {
                        hideSheet();
                        $scope.goToPayment();
                    }
                })
            }
            if ($scope.User.IsBlocked) {
                btns.push({
                    text: '<i class="icon androidOnly ion-chatbubbles"></i> Accept Communication',
                    Action: function() {
                        hideSheet();
                        _updateNetwork(true);
                    }
                })
            } else {
                btns.push({
                    text: '<i class="icon androidOnly ion-ios-pause-outline"></i> Decline Communication',
                    Action: function() {
                        hideSheet();
                        _updateNetwork(false);
                    }
                })
            }
            btns.push({
                text: '<i class="icon androidOnly ion-ios-paper-outline"></i> View Profile Details',
                Action: function() {
                    hideSheet();
                    $scope.goToProfile();
                }
            })

            if ($scope.User.SharePrivateImage) {
                btns.push({
                    text: '<i class="icon androidOnly ion-eye-disabled"></i> Restrict to Private Images ',
                    Action: function() {
                        hideSheet();
                        _sharePrivateImages(false);
                    }
                })
            } else {
                btns.push({
                    text: '<i class="icon androidOnly ion-eye"></i> Access to Private Images',
                    Action: function() {
                        hideSheet();
                        _sharePrivateImages(true);
                    }
                })
            }
            btns = btns.concat(actionBtns)
            hideSheet = $ionicActionSheet.show({
                buttons: btns,
                cancelText: '<i class="icon androidOnly ion-ios-arrow-down"></i> Cancel',
                buttonClicked: function(index) {
                    btns[index].Action();
                }
            });
        }
        /*action sheet end*/
})