app.controller('answeredQuestionCtrl', function($scope, $ionicModal, $ionicPopup ) {
    var _firstLoad = true;
    $scope.Answers = [];
    var _pageNo = 0;
    var _answersPerPage = 50;
    $scope.canLoadMore = true;
    
    $scope.$on('$ionicView.enter', function() {
        _getAnsweredQuestions(!_firstLoad);
        if(_firstLoad)
            _firstLoad = false;
    })

    $scope.updateAnswer = function(a, newAnser) {
        if(a.Answer == newAnser) return;
        a.Answer = newAnser;
        _save(a, function(success){
            if(!success){
                a.Answer = !newAnser; //reverted
                return;
            }
        });
    }
    
    var _save = function(a, callaback){
        $scope.ajaxPostPromise('SimpleQuestionApi/Save', a, true)
            .then(function(response){
                if(callaback){
                    callaback(response.Success);
                }
            },function(err){
                callaback(false);
            })
    }

    $scope.loadMore = function(){
        _pageNo++;
        _getAnsweredQuestions(false);
    }

    $scope.loading = true;
    var _getAnsweredQuestions = function(runBackground){
        $scope.loading = true;
        var request = {page : _pageNo, numberOfResults : _answersPerPage};
        $scope.ajaxGetPromise('SimpleQuestionApi/ViewAnswered', request, runBackground)
            .then(function(response){
                $scope.loading = false;
                if(!response.Success) return;
                angular.forEach(response.Payload, function(a){
                    $scope.Answers.push(a);
                })
                $scope.canLoadMore = (response.Payload.length > 0 && response.Payload.length >= _answersPerPage);
            },function(){
                $scope.loading = false;
            })
    }

    $scope.editExplaination = function(a){
        $scope.a = a;
        var myPopup = $ionicPopup.show({
            template: '<textarea rows="10" ng-model="a.Explaination"></textarea>',
            title: 'Edit',
            subTitle: a.QuestionText,
            scope: $scope,
            buttons: [{
                text: 'Cancel'
            }, {
                text: '<b>Save</b>',
                type: 'button-positive',
                onTap: function(e) {
                    _save($scope.a)
                }
            }]
        });
    }

})