app.controller('fbImagesCtrl', function($scope, $ionicModal, $ionicSlideBoxDelegate, popupService, facebookApiService, $filter) {
    var _filter = $filter('filter');
    $scope.securityOptions = [{'Id' : 1 ,'Value' : "Everyone",'Active':false},{'Id' : 2 ,'Value' : "Members only",'Active':false},{'Id' : 3 ,'Value' : "Paid members only",'Active':false},{'Id' : 4 ,'Value' : "In Communication",'Active':false},{'Id' : 5 ,'Value' : "Give access to",'Active':false},{'Id' : 6 ,'Value' : "No one except me",'Active':false}];
    $scope.FacebookImages = [];
    var _firstLoad = true;
    var _loaded = false;
    var _uploadingImageCount = 0;
    $scope.$on('$ionicView.enter', function() {
        if (_firstLoad || !_loaded) {
            _isUserLoggedIn();
            _firstLoad = false;
        }
    });
    
    $scope.startUpload = function(){
        var selectedImages = _filter($scope.FacebookImages,{Selected : true});
        if(selectedImages.length == 0){
            toastr.info('Please select image(s) before uploading.')
            return;
        }
        _uploadingImageCount = selectedImages.length;
        if($scope.CurrentUser.ShortDetails.CoverImage == '')
            selectedImages[0].IsCover = true;
        angular.forEach(selectedImages, function(image){
            _convertImgToBase64URL(image.OrignalImage, image.IsCover)
        })
    }

    var _convertImgToBase64URL = function(url, IsCover){
        var img = new Image();
        img.crossOrigin = 'Anonymous';
        img.onload = function(){
            var canvas = document.createElement('CANVAS'),
            ctx = canvas.getContext('2d'), dataURL;
            canvas.height = this.height;
            canvas.width = this.width;
            ctx.drawImage(this, 0, 0);
            dataURL = canvas.toDataURL("image/jpeg");
            _uploadImage(dataURL, IsCover)
            canvas = null; 
        };
        img.src = url;
    }

    var _uploadImage = function (base64EncodedString, IsCover) {
        var me = this;
        base64EncodedString = base64EncodedString.replace("data:image/jpeg;base64,", "");
        var url = "ProfileImageApi/Save";
        var data = {
            Base64_encodedString: base64EncodedString,
            IsCover: IsCover,
            SecurityLevel: 1,
            Source : 'FromMobileFB'
        };

        $scope.ajaxPostPromise(url, data)
            .then(function(response){
                _uploadingImageCount--;
                if(_uploadingImageCount == 0){
                    $scope.imageUploadedForApproval = true;
                    angular.forEach($scope.FacebookImages, function(i){
                        i.Selected = false;
                    })
                }
            })
    }

    var _updateActiveService = function(n){
        $scope.$apply(function(){
            $scope.updateActiveService(n)
        })
    }

    var _isUserLoggedIn = function(){
    	_updateActiveService(1)
    	facebookApiService.IsUserLoggedIn(function(isLoggedIn){
    		_updateActiveService(-1)
    		if(isLoggedIn){
    			_checkPhotoPermission();
    		}else{
    			_fbLogin();
    		}
    	}, function(){
            _updateActiveService(-1)
        })
    }

    var _fbLogin = function(){
    	_updateActiveService(1)
    	facebookApiService.login('user_photos', function(response) {
    		_updateActiveService(-1);
    	    if (response.authResponse) {
    	        _checkPhotoPermission();
    	    } else {

    	    }
    	}, function(e) {
            _updateActiveService(-1);
    	    alert('Facebook: Login Failed or didn\'t fully authorize. Message: ' + e.errorMessage);
    	});
    }
    
    var _checkPhotoPermission = function(){
    	_updateActiveService(1)
    	facebookApiService.hasPhotoPermission(function(hasPhotoPermission) {
    		_updateActiveService(-1)
    	    if (hasPhotoPermission) {
                _updateActiveService(1)
    	        facebookApiService.getProfileAlbum(_onGetFbImagesComplete);
    	    } else {
    	        _reAskPermission();
    	    }
    	})
    }

    var _reAskPermission = function(){
    	_updateActiveService(1)
		facebookApiService.login('user_photos', function (response) {
			_updateActiveService(-1)
            // handle the response
            if (!response || response.error)
                return;
            if (response.status == 'connected') {
                _checkPhotoPermission();
            }
        }, function(e){
        	_updateActiveService(-1)
		}, 'rerequest');
	}

    var _onGetFbImagesComplete = function(success, images) {
        //alert(JSON.stringify(images));
        if (success) {
            _updateActiveService(-1);
            $scope.$apply(function() {
                $scope.FacebookImages = images;
                _loaded = true;
            })
        }else{
            _updateActiveService(-1);
        }
    }
});