app.controller('iosPaymentPlanCtrl', function($scope, urlService, $state, $ionicHistory) {
    $scope.Products = [];
    $scope.InAppPurchases = {};
    /*debuggin helpers*/
    var _try = function(func){
        try{
            func();
        }catch(err){
            alert(err.message)
        }
    }
    var _alert = function(obj){
        //alert(JSON.stringify(obj));
    }

    /*debugging helpers end*/
    var _onInitializeDataComplete = function(data) {
        $scope.Products = data.Payload.Products;
        $scope.InAppPurchases.load();
    }

    var _initializeData = function() {
        var data = {
            plan: 'ios'
        }
        $scope.ajaxGetPromise('PaymentPlansApi/Index', data)
            .then(_onInitializeDataComplete)
    }

    $scope.InAppPurchases.load = function() {
        _try(function(){
            if (!window.inAppPurchase) {
                alert('Error: Could not load inAppPurchase');
                return
            }

            // make array of products gateway id
            productsIds = [];
            angular.forEach($scope.Products, function(p){
                productsIds.push(p.GatewayId);
            })
            
            $scope.updateActiveService(1)
            inAppPurchase.getProducts(productsIds)
                .then(function(products) {
                    _alert(products);
                    _updateActiveService(-1);
                    if (products.length == 0)
                        alert('No product found')
                }).catch(function(err) {
                    alert(err.errorMessage);
                    _updateActiveService(-1);
                });
        })
    }

    var _updateActiveService = function(n) {
        $scope.$apply(function() {
            $scope.updateActiveService(n)
        })
    }

    $scope.buy = function(product) {
        _try(function(){
            if (!$scope.CurrentUser.ShortDetails.IsPaid) {
                $scope.updateActiveService(1)
                inAppPurchase.buy(product.GatewayId)
                    .then(function(data) {
                        _updateActiveService(-1);
                        $scope.SaveTransaction(data.transactionId, product.GatewayId, data.receipt)
                    })
                    .catch(function(err) {
                        alert(err.errorMessage);
                        _updateActiveService(-1);
                    });
            }
        })
    };

    $scope.SaveTransaction = function(transactionId, productId, receipt) {
        var data = {
            TransactionId: transactionId,
            ProductId: productId,
            Receipt: receipt
        }
        $scope.ajaxPostPromise('PaymentPlansApi/IosPerformInAppPurchase', data)
            .then(function(response) {
                $scope.OnSaveTransactionComplete(response);
            })
    }

    $scope.OnSaveTransactionComplete = function(data) {
        if (data.Payload.StatusCode != 0) {
            alert("We could'nt confirm your receipt, server returned code ", data.StatusCode);
            return;
        }
        $scope.CurrentUser.ShortDetails.IsPaid = true;
        $ionicHistory.clearCache()
            .then(function(){
                $state.go('home.explore') 
            })
    }
    _initializeData();
});