app.controller('mainCtrl', function($scope, $timeout, $ionicModal, $ionicNativeTransitions, $interval, popupService) {
    $scope.ProfileCompletion;
    $scope.CompletionItems = [];

    /*interval to update profile image*/
    $interval(function(){
        if(!$scope.isCurrentState('home.settingMain'))
             return;
        $scope.ajaxGetPromise('ProfileImageApi/GetCoverImage', null, true)
            .then(function(response){
                if(!response.Success) return;
                $scope.CurrentUser.ShortDetails.CoverImage = response.Payload.CoverImage;
            })
    }, 30000)

    $scope.NotificationUnreadCount = 0;
    $scope.AdminMsgUnreadCount = 0;
    $interval(function(){
        if(!$scope.isCurrentState('home.settingMain'))
             return;
        $scope.ajaxGetPromise('ProfileNotificationApi/UnreadCount', null, true)
            .then(function(response){
                if(!response.Success) return;
                $scope.NotificationUnreadCount = response.Payload.Count;
            })

        $scope.ajaxGetPromise('AdminMessageApi/GetUnreadCount', null, true)
            .then(function(response){
                if(!response.Success) return;
                $scope.AdminMsgUnreadCount = response.Payload.Count;
            })
    }, 20000)

    var _firstLoad = true;
    $scope.$on('$ionicView.enter', function() {
        _getProfileCompletion();//runs in background
        _setProfileIncompleteItems();
	});
    
    $scope.ProfileCompletion = $scope.CurrentUser.ProfileCompletion;

    var _getProfileCompletion = function(){
        var promise = $scope.ajaxGetPromise('DashboardApi/GetProfileCompletion', null, true);
        promise.then(function(response){
            if(!response.Success) return;
            $scope.ProfileCompletion = response.Payload;
            _setProfileIncompleteItems();
        })
    }

    var _profileCompletionList = {
		ProfileQuestions	:	'Answer at least 5 profile questions <br/><b>40 points / per item</b>',
		EmailVerification	:	'Get your email address verified <br/><b>200 points</b>',
		ProfileImage		:	'Upload a cover image <br/><b>200 points</b>',
		MatchQuestions		:	'Answer at least 20 match questions <br/><b>5 points / per item</b>',
		ProfileDetails		:	'Complete profile details <br/><b>10 points / per item</b>',
		Images				:	'Upload at least 5 images <br/><b>100 points / per item - max 500</b>',
		PaidUser			:	'Subscribe for a plan <br/><b>500 points</b>'
	}

    $scope.showDiv = false;
    $scope.profileComDiv = function(){
        $scope.showDiv = !$scope.showDiv;
    }

    var _setProfileIncompleteItems = function(){
        var incompleteItems = $scope.ProfileCompletion.IncompleteItems;
        $scope.CompletionItems = [
            { text : _profileCompletionList.ProfileQuestions, sref : 'home.profile_edit', Incomplete : ((incompleteItems & 0x1) == 0x1)},
            { text : _profileCompletionList.MatchQuestions, sref : 'home.questionAnswer', Incomplete : ((incompleteItems & 0x2) == 0x2)},
            { text : _profileCompletionList.ProfileImage, sref : 'home.profile_edit', Incomplete : ((incompleteItems & 0x4) == 0x4)},
            { text : _profileCompletionList.Images, sref : 'home.profile_edit', Incomplete : ((incompleteItems & 0x8) == 0x8)},
            { text : _profileCompletionList.EmailVerification, sref : 'home.profile_edit', Incomplete : ((incompleteItems & 0x10) == 0x10)},
            { text : _profileCompletionList.PaidUser, sref : 'home.settings', Incomplete : ((incompleteItems & 0x20) == 0x20), ClickHandler : $scope.showPlanPage},
            { text : _profileCompletionList.ProfileDetails, sref : 'home.profile_edit', Incomplete : ((incompleteItems & 0x40)  == 0x40)}
        ]
    }

    /*feedback start*/
    var _feedbackModal, _myPlanModal;
    var _loadModal = function() {
        $ionicModal.fromTemplateUrl('templates/modals/feedBackModal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            _feedbackModal = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modals/myPlanModal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            _myPlanModal = modal;
        });

        $ionicModal.fromTemplateUrl('templates/modals/restrictedProfileModal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            _restrictedProfileModal = modal;
        });

    }
    
    $scope.showPlanPage = function(){
        if($scope.CurrentUser.ShortDetails.IsPaid){
            _myPlanModal.show();
        }else{
            $scope.goToPayment();
        }
    }

    $scope.HidePlanPage = function(){
        _myPlanModal.hide();
    }

    $scope.navigateTo = function(p){
        _myPlanModal.hide();
        if(p == 'explore'){
            $ionicNativeTransitions.stateGo('home.explore', {}, {}, {
                "type": "slide",
                "direction": "left"
            });
        }else if(p == 'payment'){
            $scope.goToPayment();
        }
    }
    
    $scope.showRestrictionReason = function(){
        _restrictedProfileModal.show();
    }

    $scope.submitForReview = function(){
        popupService.confirm("Are you sure you have completed the required changes and now want to review your profile by our team?",function(ok){
            if(ok){
                $scope.ajaxPostPromise('ProfileApi/SubmitReviewStatus')
                    .then(function(response){
                        if(!response.Success) return;
                        $scope.CurrentUser.ShortDetails.ProfileStatus = 3;
                        _restrictedProfileModal.hide();
                    })                
            }
        })
    }
    
    $scope.closeRestrictionModal = function(){
        _restrictedProfileModal.hide();
    }

    $timeout(function() {
        _loadModal();
    }, 500);

    $scope.feedbackModal = function(){
        $scope.FeedbackSubmitted = false;
        _feedbackModal.show();
    }

    $scope.hideFeedbackModal = function(){
        _feedbackModal.hide();
    }

    $scope.FeedbackSubmitted = false;
    $scope.FeedbackRequest = {Rating : 3};
    $scope.SubmitFeedback = function(request) {
        request.ProfileId = $scope.CurrentUser.ShortDetails.Id;
        var promise = $scope.ajaxPostPromise('FeedbackApi/Submit', request);
        promise.then(function(response) {
            if (!response.Success)
                return;
            $scope.FeedbackSubmitted = true;
            $scope.FeedbackRequest = {};
        })
    }
    /*feedback end*/
});
