app.controller('notificationsCtrl', function ($scope, $ionicPopup, pushNotificationService, $ionicActionSheet, $filter, $ionicScrollDelegate,$ionicNativeTransitions, popupService) {
	$scope.notifications = [];
	var _notificationsResponse = [];
	var _firstLoad = true;
	$scope.$on('$ionicView.enter', function() {
	    _getNotifications(!_firstLoad);
	    _firstLoad = false;
	});

	var _getNotifications = function(background, showAll){
		$scope.ajaxGetPromise('ProfileNotificationApi/List', {showAll : showAll}, background)
			.then(_onGetNotificationsComplete)
	}
	
	var _onGetNotificationsComplete = function(response){
		if(!response.Success) return;
		_notificationsResponse = response.Payload;
		$scope.notifications = angular.copy(_notificationsResponse);
	}

	$scope.goTo = function(pageId){
		var state = '';
		switch(pageId){
			case '#favorited_me':
			case '#message_t':
			case '#rated_me':
				state = 'home.matchMain';
				break;
			case '#my_photos':
				state = 'home.profile_edit';
				break;
			case '#user_question':
				state = 'home.questionAnswer';
				break;
		}
		if(state == '') return;
		$ionicNativeTransitions.stateGo(state, {}, {}, {
		    "type": "slide",
		    "direction": "up"
		});
	}

	var _applyFilters = function(type){
		var types = []
		switch(type){
			case 'profile_notifications':
				types = ['CommunicationDeclined','PendingNetworkConnection','PaymentExpired', 'PaymentReceived', 'FourStarRating', 'FiveStarRating', 'Favorited', 'BothFavorited']
				break;
			case 'from_admin':
				types = ['ProfileStatusAlert', 'AdminComments']
				break;
			case 'approvals':
				types = ['QuestionApproved', 'ImageApproved']
				break;
			case 'rejections':
				types = ['ImageRejected', 'QuestionRejected']
				break;
			default:
				break;
		}
		var filtered = new Array();
		angular.forEach(types, function(t){
			var results = $filter('filter')(_notificationsResponse, {Type : t}, true);
			filtered = filtered.concat(results);
		})
		filtered = $filter('orderBy')(filtered, 'DateCreated', true)

		$scope.notifications = angular.copy(filtered);
		$ionicScrollDelegate.resize();
	}

	/*action sheet start*/
    var hideSheet;
    var actionBtns = [
        {
        text: 'Profile Notifications',
        Action: function() {
        	_applyFilters('profile_notifications')
            hideSheet();
        }
    },{
        text: 'From Admin',
        Action: function() {
        	_applyFilters('from_admin')
            hideSheet();
        }
    }, {
        text: 'Approvals',
        Action: function() {
        	_applyFilters('approvals')
            hideSheet();
        }
    }, {
        text: 'Rejections',
        Action: function() {
        	_applyFilters('rejections')
            hideSheet();
        }
    },  {
        text: 'Show All',
        Action: function() {
        	_getNotifications(true,true)
            hideSheet();
        }
    }];

    $scope.showFilters = function() {
        hideSheet = $ionicActionSheet.show({
            buttons: actionBtns,
            cancelText: 'Cancel',
            cancel: function() {
                // add cancel code..
            },
            buttonClicked: function(index) {
                actionBtns[index].Action();
            }
        });
    }
  	
  	$scope.sendVerificationEmail = function(){
		$scope.ajaxPostPromise('AccountApi/ResendVerficationEmail')
  			.then(function(response){
  				if(!response.Success)
  					return;
  				var msg = "Verification email sent at "+$scope.CurrentUser.AccountInfo.Email+" Please follow the instructions in that email"
  				popupService.show(msg)
  			})
  	}
})