app.controller('profileDetailSliderCtrl', function($scope, $ionicSlideBoxDelegate, popupService,$timeout, $filter, $ionicScrollDelegate) {
    $scope.showLoading = true;
    $scope.activeSlide = 0;
    $scope.SectionHeader = '';
    var _currentSection = 1;
    var _filter = $filter('filter');
    var _detailsHasChanges = false;
    $scope.totalSections = 10;
    $scope.showNextSection = false;

    popupService.showSwipeMsg($scope);

    $scope.$watch('Details', function(newVal, oldValue){
        if(newVal != oldValue){
            _detailsHasChanges = true;
        }
    }, true)

    $scope.$watch('Details.OffspringCurrentId', function(newVal, oldValue){
        if(newVal != oldValue){
            _updateOffspringFutureOptions();
        }
    }, true)
    
    $scope.$watch('Details.CountryId', function(newVal, oldValue){
        if(newVal != oldValue){
            _updateStates(newVal);
        }
    }, true)
    
    var _updateStates = function(CountryId){
        $scope.ajaxGetPromise('ProfileApi/StateProvinces', {countryId : CountryId}, true)
            .then(function(response){
                if(!response.Success) return;
                $scope.LookupData.StateProvinces = response.Payload;
                var selected = $filter('filter')($scope.LookupData.StateProvinces, {Value : CountryId}, true)
                if(selected.length == 0){
                    $scope.Details.StateProvinceId = null;                    
                    $scope.Details.Zip = null;
                }
            })
    }

    var _updateOffspringFutureOptions = function(){
        if($scope.Details.OffspringCurrentId == null){
            $scope.LookupData.OffspringFutureOptions = [];
            return;
        }
        $scope.ajaxGetPromise('ProfileApi/OffspringFutureOptions', {offspringCurrentId : $scope.Details.OffspringCurrentId}, true)
            .then(function(response){
                if(!response.Success)
                    return;
                $scope.LookupData.OffspringFutureOptions = response.Payload;
            })
    }
    _updateOffspringFutureOptions();
    _updateStates($scope.Details.CountryId);

    var _loadSection = function(section, slideNo, initialLoad){
        _currentSection = section;
        $timeout(function() {
            $scope.Slides = _filter($scope.ProflieDetailList, {SectionNo : _currentSection}, true);
            $scope.showNextSlideIndex = (slideNo !== ($scope.Slides.length - 1))
            $scope.showNextSection = ($scope.totalSections != $scope.Slides[0].SectionNo);
            $scope.SectionHeader = $scope.Slides[0].Group;
            $timeout(function(){
                $scope.showLoading = false;
                $scope.activeSlide = slideNo;
                $ionicSlideBoxDelegate.update();
            },50);
        }, 300);
    }

    $timeout(function(){
        var index = localStorage.detailFilterIndex;
        var slide = $scope.ProflieDetailList[index];
        var slides = _filter($scope.ProflieDetailList, { SectionNo : slide.SectionNo }, true);
        var slideNo = slides.indexOf(slide)
        _loadSection(slide.SectionNo, slideNo, true);
    },10)

    $scope.NextSection = function(){
        $scope.showLoading = true;
        _loadSection(_currentSection + 1, 0);
    }

    $scope.NextSlide = function(){
        $ionicSlideBoxDelegate.next();
        $scope.showNextSection = ($scope.totalSections != $scope.Slides[0].SectionNo);
    }

    $scope.slideChanged = function(index){
        $timeout(function(){
            $ionicScrollDelegate.$getByHandle('profileDetailSlider').scrollTop();
        },10)
        if(isNaN(index)) return;
        $scope.showNextSlideIndex = (index !== ($scope.Slides.length - 1))
        $scope.Header = $scope.Slides[index].Header;
    }

    $scope.backToList = function() {
        if(_detailsHasChanges){
            _detailsHasChanges = false;
            var promise = $scope.ajaxPostPromise('ProfileApi/EditDetails', $scope.Details, true);
            promise.then(function(response){
            })
        }
        $scope.goBackDown();
    };
});