app.controller('profileEditCtrl', function($scope, $ionicModal, $ionicNativeTransitions, $ionicSlideBoxDelegate, popupService, $timeout, $ionicPopup, $filter, dynamicSliderService, $interval) {

    var profileInterestModal;
    var _firstTime = true;

    $interval(function(){
        if(!$scope.isCurrentState('home.profile_edit'))
             return;
        $scope.ajaxGetPromise('ProfileImageApi/list', null, true)
            .then(function(response){
                if(!response.Success) return;
                $scope.CurrentUser.Images = response.Payload;
                _setImages()
            })
    }, 30000)

    $scope.$on('$ionicView.enter', function() {
        if (_firstTime) {
            _flagSelected();
            _firstTime = false;
        }
        angular.forEach($scope.ProflieDetailList, function(s){
            if(!s.Single){
                $scope.Details[s.DisplayPropertyName] = _getDescritpion($scope.LookupData[s.LookupPropertyName], $scope.Details[s.ModelPropertyName])
                if(s.HasSubOptions)
                    $scope.Details[s.SubDisplayPropertyName] = _getDescritpion($scope.LookupData[s.SubListLookupProperty], $scope.Details[s.SubListModelProperty])
            }

        })
    });
        
    $scope.goToSlider = function(index){
        localStorage.detailFilterIndex = index;
        $ionicNativeTransitions.stateGo('home.profileDetailSlider', {}, {}, {
            "type": "slide",
            "direction": "up"
        });
    }

    var _flagSelected = function() {
        angular.forEach($scope.LookupData.InterestOptions, function(i) {
            i.Selected = false;
        })

        angular.forEach($scope.CurrentUser.Interests, function(item) {
            var found = false;
            for (var i = 0; i < $scope.LookupData.InterestOptions.length; i++) {
                if ($scope.LookupData.InterestOptions[i].Value == item.InterestId) {
                    found = true;
                    break;
                }
            }
            $scope.LookupData.InterestOptions[i].Selected = found;
        })
        $scope.InterestOptions = $scope.LookupData.InterestOptions;
    }

    $scope.addInterest = function(interest) {
        $scope.CurrentUser.Interests.push({
            InterestId: interest.Value,
            Description: interest.Description
        });
        _flagSelected();
        _updateProfileInterests();
    }

    $scope.removeInterest = function(i) {
        if (i.Value !== undefined)
            i.InterestId = i.Value;
        i.Selected = false;
        removeItemFrominterest(i);
        _flagSelected();
        _updateProfileInterests();
    }

    var removeItemFrominterest = function(i) {
        var selectedIndex = -1;
        angular.forEach($scope.CurrentUser.Interests, function(int, index) {
            if (int.InterestId == i.InterestId)
                selectedIndex = index;
        })
        if (selectedIndex !== -1)
            $scope.CurrentUser.Interests.splice(selectedIndex, 1);
    }

    var _updateProfileInterests = function() {
        var ids = [];
        angular.forEach($scope.CurrentUser.Interests, function(item) {
            ids.push(item.InterestId);
        });
        var promise = $scope.ajaxPostPromise('ProfileApi/UpdateInterests', {
            InterestIds: ids
        }, true);
        promise.then(function(response) {})
    }



    var _getDescritpion = $filter('GetDescription');
    //copy questions from baseCtrl
    $scope.Questions = angular.copy($scope.CurrentUser.Details.ProfileQuestions.Questions);
    $scope.init = function() {}
    $scope.selectedQuestion = {}
    $scope.openProfileQuestionEdit = function(q){
        $scope.selectedQuestion = q;

        // Custom popup
        var myPopup = $ionicPopup.show({
            templateUrl: 'templates/popup/editProfileQuestion.html',
            title: 'Edit',
            subTitle: q.Question,
            scope: $scope,

            buttons: [{
                text: 'Cancel'
            }, {
                text: '<b>Save</b>',
                type: 'button-positive',
                onTap: function(e) {
                    $scope.ajaxPostPromise('ProfileQuestionApi/SaveAnswer', $scope.selectedQuestion, true)
                      .then(function(response){
                          if(!response.Success){
                            //revert changes
                          }
                      });
                }
            }]
        });
    }
    /*Basic Information Modal*/
    $timeout(function() {
        _loadModal();
        $scope.Slides = $scope.ProflieDetailList;
        //load images async
        _setImages();
    }, 500);
    var _setImages = function(){
        $scope.ProfileImgs = [
            $scope.GetImageNo(1),
            $scope.GetImageNo(2),
            $scope.GetImageNo(3),
            $scope.GetImageNo(4),
            $scope.GetImageNo(5),
            $scope.GetImageNo(6),
        ]        
    }
    var _loadModal = function() {
        $ionicModal.fromTemplateUrl('templates/modals/profileInterestModal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            profileInterestModal = modal;
        });

    }
    /*Profile Interest Modal*/
    $scope.openProfileInterestModal = function() {
        profileInterestModal.show();
    }

    $scope.closeProfileInterestModal = function() {
        profileInterestModal.hide();
    };
});