app.controller('questionAnswerCtrl', function($scope, $ionicModal) {
    $scope.noMoreQuestions = false;
    $scope.explaination = {};
    var _questionsToFetchPerRequest = 20;
    $scope.addExplanation = true;

    //Add Explanation divShow Hide
    $scope.addExplanationDiv = function(){
        if($scope.addExplanation){
            $scope.addExplanation = false;
        }else{
            $scope.addExplanation = true;
        }
    }
    
    //question cards
    var cards = [];
    $scope.cards = [];
    var _firstLoad = true;
    $scope.$on('$ionicView.enter', function() {
        if(_firstLoad || cards.length == 0){
            _getNextQuestions();
            _firstLoad = false;
        }
    })

    $scope.$watch('cards.length', function(newVal, oldVal){
        if(newVal === 0 && cards.length === 0 && !_firstLoad){
            _getNextQuestions();
        }
    })

    var _getNextQuestions = function(){
        $scope.ajaxGetPromise('SimpleQuestionApi/GetNextBulk', {NumberOfQuestionsToGet : _questionsToFetchPerRequest})
            .then(function(response){
            if(!response.Success) return;
                cards = response.Payload.Questions;
                $scope.noMoreQuestions = cards.length == 0;
                _addCards(2);
            })
    }

    var _addCards = function(quantity) {
        for (var i = 0; i < Math.min(cards.length, quantity); i++) {
            $scope.cards.push(cards[0]);
            cards.splice(0, 1);
        }
    }

    $scope.cardDestroyed = function(index, answer, isSkipped) {
        $scope.addExplanation = true;
        var question = $scope.cards.splice(index, 1)[0];
        _addCards(1);

        if(answer != undefined){
            $scope.isMoveRight = answer === true;
            $scope.isMoveLeft = answer === false;
        }
        if(isSkipped === true)
            _skipped(question.QuestionId)
        else
            _answerQuestion(question, $scope.isMoveRight, $scope.isMoveLeft, isSkipped)
        $scope.isMoveLeft = false;
        $scope.isMoveRight = false;
    };

    $scope.cardSwiped = function(index) {
        $scope.cards.push(cards[Math.floor(Math.random(1) * 8)]);
    };

    var _skipped = function(questionId){
        $scope.ajaxPostPromise('SimpleQuestionApi/Skip', {QuestionId : questionId}, true)
            .then(function(response){
                //TODO: some action upon failure
            })
    }

    var _answerQuestion = function(question, isMoveRight, isMoveLeft){
        var request = {
            QuestionId : question.QuestionId,
            Answer : isMoveRight === true,
            Explaination : $scope.explaination.value
        }

        $scope.ajaxPostPromise('SimpleQuestionApi/Save', request, true)
            .then(function(response){
                $scope.explaination.value = '';
            })
    }

    // For reasons, the cardSwipedRight and cardSwipedLeft events don’t get called always
    // https://devdactic.com/optimize-tinder-cards/
    $scope.cardSwipedLeft = function(event, index) {
        $scope.isMoveLeft = true;
        event.stopPropagation();
    }

    $scope.cardSwipedRight = function(event, index) {
        $scope.isMoveRight = true;
        event.stopPropagation();
    }

    $scope.cardPartialSwipe = function(amt) {
        $scope.isMoveLeft = amt < -0.15;
        $scope.isMoveRight = amt > 0.15;
    }

    $scope.reset = function() {
        cards = angular.copy(resetCards);
        _addCards(2);
    }
    
    // Onload
    //_addCards(2); // 2 is the best choice for the performance
})
