app.controller('settingsCtrl', function($scope, $ionicModal, $ionicSlideBoxDelegate, popupService, $timeout, $state, $ionicPopup, pushNotificationService, facebookApiService) {
	var _newPasswordModal;

	$scope.accountSettings = $scope.CurrentUser.AccountInfo;
	var _settings = angular.copy($scope.accountSettings);
	
    $scope.$watch('accountSettings.BrowseInvisibly', function(newVal, oldValue){
		if(newVal != undefined && (newVal != oldValue))
			_updateDetail();
	})
    
    /*facebook account settings*/
    $scope.connectFacebook = function(){
    	$scope.updateActiveService(1);
    	facebookApiService.fetchPublicProfile(function(success, data){
    		$scope.$apply(function(){
    			$scope.updateActiveService(-1);
	    		if(success){
	    			var request = {
	    				FId : data.id,
	    				FEmailAddress : data.email
	    			}
	    			$scope.ajaxPostPromise('AccountApi/ConnectLoggedInUserWithFacebook', request)
	    				.then(function(response){
	    					if(response.Success){
	    						$scope.CurrentUser.FacebookAccount.FacebookLoginExist = true;
	    						$scope.CurrentUser.FacebookAccount.ExternalAccountEmail = data.email;
	    						//$scope.CurrentUser.FacebookAccount.ExternalAccountId = data.id
	    					}
	    				})
	    		}
	    		else{
	    			toastr.error('could\'nt fetch data from facebook')
	    		}
    		})
    	})
    }

    $scope.discounnectFacebook = function(){
    	popupService.confirm('Are you sure? you want to disconnect facebook account?', function(ok){
    		if(ok){
    			if(!$scope.CurrentUser.FacebookAccount.PasswordExists){
    				//get password then disconnect
    				_newPasswordModal.show();
    			}else{
    				//disconnect
    				$scope.removeFacebookAccount(undefined,undefined);
    			}
    		}
    	})
    }

    $scope.Errors = []
    $scope.removeFacebookAccount = function(newPassword, cPassword){
    	$scope.Errors = []
    	if(newPassword !== cPassword){
    		$scope.Errors.push('Passwords do not match')
    		return;
    	}
    	var url = "AccountApi/RemoveExternalAccount";
    	var data = {
    		Id: $scope.CurrentUser.FacebookAccount.ExternalAccountId,
	        Password : newPassword
    	}
    	$scope.ajaxPostPromise(url, data)
    		.then(function(response){
    			if(response.Success){
    				$scope.CurrentUser.FacebookAccount.FacebookLoginExist = false;
    				_newPasswordModal.hide();
    			}
    		})
    }

    /*facebook account settings end*/
	$scope.$watch('accountSettings.IsNotificationPermitted', function(newVal, oldValue){
		if(newVal != undefined && (newVal != oldValue))
			_updateDetail();
	})

	$scope.DeleteProfile = function(){
		var myPopup = $ionicPopup.confirm({
			title: 'Are You Sure',
			template : '<p>By deleting account, you will not appear in searches or other activities.</p>',
			scope: $scope,
			buttons: [
			{ text: 'Cancel' },
			{
				text: '<b>Yes</b>',
				type: 'button-assertive',
				onTap: function(e) {
					$scope.accountSettings.IsUserDisabled = true;
					_updateDetail(true);
				}
			}
			]
		});
	}

	var _updateDetail = function(logout){
		var promise = $scope.ajaxPostPromise('AccountApi/AccountDetail', $scope.accountSettings, true);
		promise.then(function(response){
			if(!response.Success){
				$scope.CurrentUser.AccountInfo = _settings;// reset older settings
				$scope.accountSettings = _settings;
				return;
			}
			_settings = angular.copy($scope.accountSettings);
			if(logout)
				$scope.Logout();
		})
	}

	$scope.Logout = function(){
		try{
			if(localStorage.facebook_login == 'true'){
				facebookApiService.logout();
			}
			
			$scope.resetToken();
			window.localStorage.removeItem('AdvanceFilters');
			window.localStorage.removeItem('Email');
			window.localStorage.removeItem('Password');
			window.localStorage.removeItem('facebook_login');
			window.localStorage.removeItem('firstLoginTime');
			
			if(localStorage.IsPushNotificationEnabled == 'true')
				pushNotificationService.unRegister();
			window.localStorage.removeItem('IsPushNotificationEnabled')
		}catch(err){
			
		}
		$state.go('public.welcome');
	}

	/*modal start*/
	$scope.hideModal = function(){
		_newPasswordModal.hide();
	}
	var _loadModal = function() {
	    $ionicModal.fromTemplateUrl('templates/setting/passwordModal.html', {
	        scope: $scope,
	        animation: 'slide-in-up'
	    }).then(function(modal) {
	        _newPasswordModal = modal;
	    });
	}

	$timeout(function() {
	    _loadModal();
	}, 500);
	/*modal end*/
})
