app.controller('userRegistrationCtrl', function($scope, $filter,facebookApiService, $stateParams, $http) {
    var _getDescritpion = $filter('GetDescription');
    $scope.Errors = [];
    var _geoLocation = null;
    $scope.isEmailUnique = true;
    $scope.isUsernameUnique = true;

    $scope.FacebookRegistration = false;
    $scope.ShowDenomination = false;
    $scope.selectedDenominationValue = "More";
    $scope.themeclr = "femaleTheme";
    $scope.user = {
    	Gender : 'F',
    	Age : 26,
    	DenominationId : 8,
    	MaritalStatusId : 1,
    	DobDay : 1,
        DobMonth : 1,
        DobYear : moment().add(-26,'y').format('YYYY'),
        EulaAccepted : false
    };
    
    var _setErrors = function(validationErros){
        angular.forEach(validationErros, function(err){
            $scope.Errors[err.Key] = err.Message;
        })
    }

    $http.get('http://ip-api.com/json')
        .then(function(response){
			$scope.user.Latitude = response.data.lat;
			$scope.user.Longitude = response.data.lon;
			$scope.user.CountryAbbreviation = response.data.countryCode;
        });

    $scope.register = function() {
    	$scope.Errors = {};
    	$scope.user.DobYear = moment().add('y', -1 * parseInt($scope.user.Age)).format('YYYY')
        if($scope.FacebookRegistration)
            $scope.user.Password = 'Password1';
        
        var verificationObj = $scope.getVerificationToken($scope.user.Email, $scope.user.Password)
        var headers = { VerificationToken : verificationObj.Hash };
        $scope.user.Ticks = verificationObj.Ticks;
        var url = 'RegistrationApi/new';
        if($scope.FacebookRegistration){
            $scope.user.Password = 'Password1';
        }
        
		$scope.user.CompanyId = $scope.CompanyId;
		$scope.user.DeviceModel =    device.model;
		$scope.user.DevicePlatform = device.platform + ' ' + device.version;
		$scope.user.ApplicationVersion = 'Ionic ' + $scope.AppVersion;

        $scope.ajaxPostPromise(url, $scope.user, false, headers)
            .then(function(response) {
            if(!response.Success){
                _setErrors(response.Payload.ValidationErrors);
                return;
            }
            if($scope.FacebookRegistration){
                localStorage['facebook_login'] = true;
            }else{
                localStorage['Email'] = $scope.user.Email;
                localStorage['Password'] = $scope.user.Password;       
            }
            $scope.$parent.LoadProfileData(response.Payload.Token, true);
        });
    };

    /*facebook registration section*/
    $scope.fetchData = function(){
        $scope.updateActiveService(1)
        facebookApiService.fetchUserDetails(function(response){
            $scope.$apply(function(){
                $scope.updateActiveService(-1)
                if(response === false){
                    toastr.error('Could\'nt fetch data from facebook.' )
                }else{
                    $scope.FacebookRegistration = true;
                    $scope.user = response;
                    var dateStr = response.DobDay +'-'+response.DobMonth +'-'+ response.DobYear
                    $scope.user.Age = $scope.GetAge(dateStr);
                }
            })
        });
    }
    /*facebook registration section end*/
    /* server validation*/
    $scope.$watch('user.Username', function(newVal){
    	if(newVal){
    		_validateUsername(newVal);
            $scope.Errors= []
    	}
    })
    
    $scope.$watch('user.Email', function(newVal){
    	if(newVal){
    		_validateEmail(newVal);
            $scope.Errors= []
    	}
    })

    var _validateEmail = function(email){
    	$scope.ajaxGetPromise('RegistrationApi/VerifyEmailIsUnique', {Email : email}, true)
    		.then(function(response){
                $scope.isEmailUnique = response.Success;
    			if(!response.Success)
                    $scope.Errors.Email = "The email entered has already been taken. Please try another.";
    		})
    }

    var _validateUsername = function(username){
    	$scope.ajaxGetPromise('RegistrationApi/VerifyUsernameIsUnique', {Username : username}, true)
    		.then(function(response){
                $scope.isUsernameUnique = response.Success;
    			if(!response.Success)
				    $scope.Errors.Username = "The username entered has already been taken. Please try another.";
    		})
    }
    /* server validation end*/
    
    /* theame related*/
    $scope.$watch('user.Gender', function(newVal, oldVal){
    	if(newVal){
    		if (newVal == "F") {
    		    $scope.themeclr = "femaleTheme";
    		} else {
    		    $scope.themeclr = "maleTheme";
    		}	
    	}
    })

    $scope.$watch('user.DenominationId', function(newVal, oldVal){
    	if(newVal){
    		$scope.ShowDenomination = (newVal == 'more')
    		$scope.selectedDenominationValue = (  newVal == 8 || newVal == 1 || newVal == 2 || newVal == "more")
    			? 'More'
    			: _getDescritpion($scope.LookupData.Denominations, newVal);
    	}
    })
    /* theame related end*/

    if($stateParams.fetchFacebookData == true){
        $scope.fetchData();
    }
});