'use strict';

app.filter('monthName', function () {
    return function (monthNumber) {
        var monthNames = [ 'January', 'February', 'March', 'April', 'May', 'June',
            'July', 'August', 'September', 'October', 'November', 'December' ];
        return monthNames[monthNumber - 1];
    }
});

/*
* items : orignal object array array
* filters : list of values
* proprty : define the property against which the items object propery should 
*			be compared to filters items
*/
app.filter('arrayFilter', function() {
  return function(items, filters, property) {
  		if(!Array.isArray(items))
  			return [];
  		if(!Array.isArray(filters))
  			return items;
  		var newList = angular.copy(items);
  		angular.forEach(newList, function(item){
  		    var ischecked = false;
  		    angular.forEach(filters, function(f){
  		        if(f == item[property]){
  		            ischecked = true;
  		        }
  		    })
  		    item.IsChecked = ischecked;
  		})        
  		return newList;
  };
});

app.filter('CheckedItemFilter', function() {
  return function(items) {
      if(!Array.isArray(items))
        return [];
      var checkedItems = [];
      angular.forEach(items, function(i){
        if(i.IsChecked == true)
          checkedItems.push(i.Value);
      })
      return checkedItems;
  };
});

app.filter('GetDescription', function() {
  return function(items, id) {
      if(!Array.isArray(items))
        return '';
      for(var i = 0; i<items.length; i++){
        if(id == items[i].Value){
          return  items[i].Description;
        }
      }
      return '';
  };
});

app.filter('Calender', function() {
  return function(value){
      return moment.utc(value, 'YYYY-MM-DDTh:mm:ss').local().calendar();
  }
})