app.config(function($stateProvider, $urlRouterProvider) {
    $urlRouterProvider.otherwise('/public/welcome');
    $stateProvider
    .state('public', {
        url: '/public',
        templateUrl: 'templates/welcome/index.html',
    })
    .state('public.welcome', {
        url: '/welcome',
        templateUrl: 'templates/welcome/welcome.html',
        controller: 'WelcomeCtrl'
    })
	.state('public.accountNotExist', {
        url: '/accountNotExist',
        templateUrl: 'templates/welcome/accountNotExist.html',
        controller: 'WelcomeCtrl'
    })

	.state('public.associateAccount', {
        url: '/associateAccount',
        templateUrl: 'templates/welcome/associateAccount.html',
        controller: 'associateAccountCtrl',
        params:{
            FacebookId : {value : '0'},
            FacebookEmail : {value : ''}
        }
    })

    .state('public.user_register', {
        url: '/user_register',
        templateUrl: 'templates/welcome/user_register.html',
        controller: 'userRegistrationCtrl',
        params:{
            fetchFacebookData:{
                value : 'false'
            }
        }
    })

    .state('public.forgotPassword', {
        url: '/forgotPassword',
        templateUrl: 'templates/welcome/forgotPassword.html',
        controller: 'forgotPasswordCtrl'
    })

    .state('public.adminLogin', {
        url: '/adminLogin',
        templateUrl: 'templates/welcome/adminLogin.html',
        controller: 'adminLoginCtrl'
    })

	.state('public.sign_in', {
        url: '/sign_in',
        templateUrl: 'templates/welcome/sign_in.html',
        controller: 'signinCtrl'
    })
    
    .state('public.facebookRegistration', {
        url: '/facebookRegistration',
        templateUrl: 'templates/welcome/facebookRegistration.html',
        controller: 'facebookRegistrationCtrl'
    })

    .state('home', {
        url: '/home',
        templateUrl: 'templates/home/index.html'
    })

    // .state('match', {
    //     url: '/matches',
    //     templateUrl: 'templates/match/index.html'
    // })

    // .state('setting', {
    //     url: '/settings',
    //     templateUrl: 'templates/setting/index.html'
    // })
    // .state('home.main', {
    //     url: '/',
    //     templateUrl: 'templates/match/main.html',
    //     controller: 'MatchesCtrl'
    // })
    .state('home.deletedProfile',{
        url : '/deletedProfile',
        templateUrl : 'templates/home/deletedProfile.html',
        controller : 'deletedProfileCtrl'
    })
     .state('home.matchMain', {
        url: '/matchMain',
        templateUrl: 'templates/match/main.html',
        controller: 'matchesCtrl'
    })
    
    .state('home.explore', {
        url: '/explore',
        templateUrl: 'templates/home/explore.html',
        controller: 'exploreCtrl'
    })

    .state('home.settingMain', {
        url: '/settingMain',
        templateUrl: 'templates/setting/main.html',
        controller: 'mainCtrl'
    })
    
    .state('home.profile_edit', {
        url: '/profile_edit',
        templateUrl: 'templates/setting/profile_edit.html',
        controller: 'profileEditCtrl'
    })

    .state('home.fbImages', {
          url: '/fbImages',
          templateUrl: 'templates/setting/fbImages.html',
          controller: 'fbImagesCtrl'
      })

    .state('home.createQuestion', {
          url: '/createQuestion',
          templateUrl: 'templates/setting/createQuestion.html',
          controller: 'createQuestionCtrl'
      })

    .state('home.settings', {
        url: '/settings',
        templateUrl: 'templates/setting/settings.html',
        controller: 'settingsCtrl'
    })

    .state('home.completeTask', {
    url: '/completeTask',
    templateUrl: 'templates/setting/completeTask.html',
    controller: 'mainCtrl'
    })
    
    .state('home.notifications', {
        url: '/notifications',
        templateUrl: 'templates/setting/notifications.html',
        controller: 'notificationsCtrl'
    })

    .state('home.premiumFeatures', {
        url: '/premiumFeatures',
        templateUrl: 'templates/setting/premiumFeatures.html',
        controller: 'mainCtrl'
    })

    .state('home.paymentPlan', {
        url: '/paymentPlan',
        templateUrl: 'templates/setting/paymentPlan.html',
        controller: 'paymentPlanCtrl'
    })

    .state('home.iosPaymentPlan', {
        url: '/iosPaymentPage',
        templateUrl: 'templates/setting/paymentPlan.html',
        controller: 'iosPaymentPlanCtrl'
    })

    .state('home.questionAnswer', {
        url: '/questionAnswer',
        templateUrl: 'templates/setting/questionAnswer.html',
        controller: 'questionAnswerCtrl'
    })
    
    .state('home.changePassword', {
        url: '/settings/changePassword',
        templateUrl: 'templates/setting/changePassword.html',
        controller: 'changePasswordCtrl'
    })

    .state('home.privacyPolicy', {
        url: '/settings/privacyPolicy',
        templateUrl: 'templates/setting/privacyPolicy.html',
        controller: 'settingsCtrl'
    })

    .state('home.termsOfUse', {
        url: '/settings/termsOfUse',
        templateUrl: 'templates/setting/termsOfUse.html',
        controller: 'settingsCtrl'
    })

    .state('home.chat', {
        url: '/chat',
        params : {
            User : {value : null, hiddenParam : 'YES'},
            ProfileId  : { value : 0, hiddenParam: 'YES' },
            // Username  : { value : '', hiddenParam: 'YES' },
        },
        templateUrl: 'templates/match/chat.html',
        controller: 'chatCtrl'
    })
    
    .state('home.search_filter', {
        url: '/search_filter',
        templateUrl: 'templates/home/search_filter.html',
        controller: 'searchFilterCtrl'
    })

    .state('home.basicFilterSlider', {
        url: '/basicFilterSlider',
        templateUrl: 'templates/home/basicFilterSlider.html',
        controller: 'basicFilterSliderCtrl',
        params : {Index :{value : 0}}
    })

    .state('home.advance_filter', {
        url: '/advance_filter',
        templateUrl: 'templates/home/advance_filter.html',
        controller: 'advanceFilterCtrl'
    })

    .state('home.advanceFilterSlider', {
        url: '/advanceFilterSlider',
        templateUrl: 'templates/home/advanceFilterSlider.html',
        controller: 'advanceFilterSliderCtrl'
    })

    .state('home.profileDetailSlider', {
        url: '/profileDetailSlider',
        templateUrl: 'templates/setting/profileDetailSlider.html',
        controller: 'profileDetailSliderCtrl'
    })

    .state('home.answeredQuestions', {
        url: '/answeredQuestions',
        templateUrl: 'templates/setting/answeredQuestions.html',
        controller: 'answeredQuestionCtrl'
    })
    .state('home.skippedQuestions', {
        url: '/skippedQuestions',
        templateUrl: 'templates/setting/skippedQuestions.html',
        controller: 'skippedQuestionsCtrl'
    })
    .state('home.profile', {
        url: '/profile',
        templateUrl: 'templates/home/profile.html',
        controller: 'profileCtrl',
        params: {
            ProfileId : { value: '0' },
            hiddenParam: 'YES',
        }
    })
    .state('home.adminChat', {
        url: '/adminChat',
        templateUrl: 'templates/home/adminChat.html',
        controller: 'adminChatCtrl'
    })
})

.run(function($rootScope, $state) {
    $rootScope.$state = $state;
})
