app.factory('ajaxService', function (urlService, $http, $q) {
    return {
    	GetPromise: function(url, data, baseScope, isBackground){
    		var headers = this.getHeader(baseScope.Token);
    		if(isBackground !== true)
            	baseScope.activeService++;
            url = urlService.compose(url)
		  	return this.CreatePromise(url,data, baseScope, isBackground,headers);
    	},
    	PostPromise: function (url, data, baseScope, isBackground, headers) {
    		if(headers === undefined)
	          	headers = this.getHeader(baseScope.Token);
            if(isBackground !== true)
            	baseScope.activeService++;
            url = urlService.compose(url);
            return this.CreatePromise(url, data, baseScope, isBackground, headers, 'Post');
        },
        CreatePromise : function(url,data, baseScope, isBackground, headers, type){
    		var deferred = $q.defer();
        	var promise;
        	if(type == 'Post')
            	promise = $http.post(url, data, { headers: headers });
            else
            	promise = $http.get(url, { params: data, headers: headers });

            promise.then(
				function (response) {
				    if(isBackground !== true)
				    	baseScope.activeService--;
					
					if (response.data.Success == false && response.data.Messages[0] == 'Unauthorized'){
						baseScope.InitializeBase();
					}

				    if (!response.data.Success) {
				    	toastr.clear();
				        angular.forEach(response.data.Messages, function (error) {
				            toastr.error(error)
				        })
				    }
				    deferred.resolve(response.data);
				}, function (response) {
				    if(isBackground !== true)
				    	baseScope.activeService--;
				    toastr.clear();
				    toastr.error('Could\'nt reach server, make sure you have an active internet connection.');
				    deferred.reject(response);
				}
		  	)
		  	return deferred.promise;
        },
        Get: function (url, data, successCallback, errorCallback, baseScope) {
          var headers = this.getHeader(baseScope.Token);
            baseScope.activeService++;
            var promise = $http.get(urlService.compose(url), { params: data, headers: headers });
            promise.then(
				function (response) {
				    baseScope.activeService--;
				    if (!response.data.Success) {
				    	toastr.clear();
				        angular.forEach(response.data.ValidationErrors, function (error) {
				            toastr.error(error.Message)
				        })
				    }
				    if (successCallback)
				        successCallback(response.data)
				}, function (response) {
					console.log(response.status)
				    baseScope.activeService--;
				    toastr.clear();
				    toastr.error(response.status + " : " + response.statusText)
				    if (errorCallback)
				        errorCallback(response)
				}
		  	)
        },
        GetBackground: function (url, data, successCallback, errorCallback, baseScope) {
          var headers = this.getHeader(baseScope.Token);
            var promise = $http.get(urlService.compose(url), { params: data, headers: headers });
            promise.then(
				function (response) {
				    if (!response.data.Success) {
				        angular.forEach(response.data.ValidationErrors, function (error) {
				            toastr.error(error.Message)
				        })
				    }
				    if (successCallback)
				        successCallback(response.data)
				}, function (response) {
				    toastr.error(response.status + " : " + response.statusText)
				    if (errorCallback)
				        errorCallback(response)
				}
		  	)
        },
        Post: function (url, data, successCallback, errorCallback, baseScope, isSecure) {
          var headers = this.getHeader(baseScope.Token);
            baseScope.activeService++;
            url = isSecure ? urlService.composeSecure(url) : urlService.compose(url);
            var promise = $http.post(url, data, { headers: headers });
            promise.then(
				function (response) {
				    baseScope.activeService--;
				    if (!response.data.Success) {
				    	toastr.clear();
				        angular.forEach(response.data.Messages, function (error) {
				            toastr.error(error)
				        })
				    }
				    if (successCallback)
				        successCallback(response.data)
				}, function (response) {
				    baseScope.activeService--;
				    if (errorCallback) {
				        errorCallback(response)
				    }
				    else {
				    	toastr.clear();
				        toastr.error(response.status + " : " + response.statusText)
				    }
				}
		  	)
        },
        GetSync: function (url, data) {
            var re = $.ajax(
                {
                    async: false,
                    url: url,
                    data: data,
                    contentType: "application/json",
                    type: 'get',
                    success: function (response) {
                        return response;
                    },
                    error: function (response) {
				    	toastr.clear();
                        toastr.error(response.status + " : " + response.statusText)
                        return response;
                    }
                });

            return re.responseJSON;
        },
        getHeader(token){
          var h = { 'Accept': 'application/json' };
          if(token){
            h.AuthenticationToken = token;
          }
          return h;
        }
    }
});
