app.factory('dynamicSliderService', function () {
	return {
		addSlides: function(lastSlide,index, orignalSlides){
			activeSlides = [];
			if(lastSlide == 0){
			    activeSlides = [
			            angular.copy(orignalSlides[index]),
			            this._getNextSlide(index, orignalSlides),
			            this._getPreSlide(index,orignalSlides),
			        ];        
			}
			else if(lastSlide == 1){
			    activeSlides = [
			            this._getPreSlide(index,orignalSlides),
			            angular.copy(orignalSlides[index]),
			            this._getNextSlide(index,orignalSlides)
			        ];        
			}else{
			    activeSlides = [
			            this._getPreSlide(index,orignalSlides),
			            this._getNextSlide(index,orignalSlides),
			            angular.copy(orignalSlides[index]),
			        ];                    
			}
			return activeSlides;
		},
		onSlideChanged : function(i, lastSlide, activeIndex,activeSlides, orignalSlides){
			var new_direction;
			if(lastSlide==2 && i==0 ){
			    new_direction = 1;
			}else if(lastSlide==0 && i==2)
			    new_direction = -1;
			else if(lastSlide < i )
			        new_direction = 1;
			else if(lastSlide > i)
			    new_direction = -1;
			
			lastSlide = i;

			var previous_index = i === 0 ? 2 : i - 1,
			    next_index     = i === 2 ? 0 : i + 1;

			activeIndex += new_direction;

			if(activeIndex > orignalSlides.length - 1)
			    activeIndex = 0;
			if(activeIndex < 0)
			    activeIndex = orignalSlides.length - 1;
			var newSlide = new_direction > 0 ? this._getNextSlide(activeIndex,orignalSlides) : this._getPreSlide(activeIndex,orignalSlides);
			return {
				slide : newSlide, 
				index : new_direction > 0 ? next_index : previous_index,
				activeSlide : activeIndex
			};
		},
		_getPreSlide : function(index, _slides){
		    i = index == 0 ? (_slides.length-1) : (index - 1);
		    return angular.copy(_slides[i]);
		},
		_getNextSlide : function(index, _slides){
		    i = (index == _slides.length - 1) ? 0 : (index + 1);
		    return angular.copy(_slides[i]);
		}
	}
})