app.factory('listService', function () {
	return {
		advanceFilterList : function(_lookupData, gender){
			var list = [
				{
		            Header: 'Body Type',
		            Lookup: _lookupData.BodyTypes,
		            ModelPropertyName: 'BodyType',
		            DisplayPropertyName: 'BodyType',
		            QueryPropName : 'bodyTypeList',
		            IsPaid : true
		        }, {
		            Header: 'Complexion',
		            Lookup: _lookupData.Complexions,
		            ModelPropertyName: 'Complexion',
		            DisplayPropertyName: 'Complextion',
		            QueryPropName : 'complexionList',
		            IsPaid : true
		        }, {
		            Header: 'Eye Color',
		            Lookup: _lookupData.EyeColors,
		            ModelPropertyName: 'EyeColor',
		            DisplayPropertyName: 'EyeColor',
		            QueryPropName : 'eyeColorList',
		            IsPaid : true
		        }, {
		            Header: 'Career',
		            Lookup: _lookupData.Careers,
		            ModelPropertyName: 'Career',
		            DisplayPropertyName: 'Career',
		            QueryPropName : 'careerList',
		            IsPaid : true
		        }, {
		            Header: 'Profile Type',
		            Lookup: _lookupData.ProfileTypes,
		            ModelPropertyName: 'ProfileType',
		            DisplayPropertyName: 'Profile Type',
		            QueryPropName : 'profileTypeList',
		        }, {
		            Header: 'Offspring',
		            Lookup: _lookupData.OffspringOptions,
		            ModelPropertyName: 'OffSpring',
		            DisplayPropertyName: 'Off Spring',
		            QueryPropName : 'offspringCurrentList',
		        }, {
		            Header: 'Zakaat',
		            Lookup: _lookupData.ZakatOptions,
		            ModelPropertyName: 'Zakaat',
		            DisplayPropertyName: 'Zakaat',
		            QueryPropName : 'zakatList',
		        }, {
		            Header: 'Salat',
		            Lookup: _lookupData.SalatOptions,
		            ModelPropertyName: 'Salat',
		            DisplayPropertyName: 'Salat',
		            QueryPropName : 'salatList',
		        }, {
		            Header: 'Hajj',
		            Lookup: _lookupData.HajjOptions,
		            ModelPropertyName: 'Hajj',
		            DisplayPropertyName: 'Hajj',
		            QueryPropName : 'hajjList',
		        }, {
		            Header: 'Fasting',
		            Lookup: _lookupData.FastingOptions,
		            ModelPropertyName: 'Fasting',
		            DisplayPropertyName: 'Fasting',
		            QueryPropName : 'fastingList',
		        }, {
		            Header: 'Residency',
		            Lookup: _lookupData.ResidencyStatuses,
		            ModelPropertyName: 'Residency',
		            DisplayPropertyName: 'Residency',
		            QueryPropName : 'residencyStatusList',
		        }, {
		            Header: 'Min. Height',
		            Lookup: _lookupData.Heights,
		            ModelPropertyName: 'MinHeight',
		            DisplayPropertyName: 'Min Height',
		            QueryPropName : 'heightFromId',
		        }, {
		            Header: 'Max. Height',
		            Lookup: angular.copy(_lookupData.Heights),
		            ModelPropertyName: 'MaxHeight',
		            DisplayPropertyName: 'Max Height',
		            QueryPropName : 'heightToId',
		        }];

		        var list2 = [{
		            Header: 'Registered Since',
		            Lookup: _lookupData.RegisteredSinceOptions,
		            ModelPropertyName: 'RegisteredSince',
		            DisplayPropertyName: 'Registered Since',
		            QueryPropName : 'registeredSince',
		        },{
		        	Header : 'Photos',
		        	Lookup : _lookupData.ProfileImageOptions,
		        	ModelPropertyName : 'ProfileImage',
		        	QueryPropName : 'profileImage',
		        	DisplayPropertyName : 'Photos',
		        	IsRadio : true
		        },{
		            Header: 'Ethnicity',
		            Lookup: _lookupData.Ethnicities,
		            ModelPropertyName: 'Ethnicity',
		            DisplayPropertyName: 'Ethnicity',
		            QueryPropName : 'ethnicityList',
		        }, {
		            Header: 'Language',
		            Lookup: _lookupData.Languages,
		            ModelPropertyName: 'Language',
		            DisplayPropertyName: 'Language',
		            QueryPropName : 'primaryLanguageList',
		        }, {
		            Header: 'Education',
		            Lookup: _lookupData.EducationLevels,
		            ModelPropertyName: 'Education',
		            DisplayPropertyName: 'Education',
		            QueryPropName : 'educationLevelList',
		        }, {
		            Header: 'Partner Work',
		            Lookup: _lookupData.PartnerWorkStatusOptions,
		            ModelPropertyName: 'PartnerWork',
		            DisplayPropertyName: 'Partner Work',
		            QueryPropName : 'partnerWorkStatusList',
		        }, {
		            Header: 'Diet',
		            Lookup: _lookupData.Diets,
		            ModelPropertyName: 'Diet',
		            DisplayPropertyName: 'Diet',
		            QueryPropName : 'dietList',
		        }, {
		            Header: 'Drink',
		            Lookup: _lookupData.DrinkingAnswerOptions,
		            ModelPropertyName: 'Drinks',
		            DisplayPropertyName: 'Drinks',
		            QueryPropName : 'drinkingAnswerList',
		        }, {
		            Header: 'Smoke',
		            Lookup: _lookupData.SmokingAnswerOptions,
		            ModelPropertyName: 'Smokes',
		            DisplayPropertyName: 'Smokes',
		            QueryPropName : 'smokingAnswerList',
		        }, {
		            Header: 'Drugs',
		            Lookup: _lookupData.DrugAnswerOptions,
		            ModelPropertyName: 'Drugs',
		            DisplayPropertyName: 'Drugs',
		            QueryPropName : 'drugsAnswerList',
		        }, {
		            Header: 'Income',
		            Lookup: _lookupData.IncomeCurrencyOptions,
		            ModelPropertyName: 'Income',
		            DisplayPropertyName: 'Income',
		            QueryPropName : '',
		            Last: true
		        }
		    ];
		    if(gender == 'M'){
		    	list.push({
		            Header: 'Hijab',
		            Lookup: _lookupData.HijabOptions,
		            ModelPropertyName: 'HijabId',
		            DisplayPropertyName: 'Hijab',
		            QueryPropName : 'hijabList',
		            ForGender : 'M'
		        })
		    }else{
		    	list.push({
		            Header: 'Facial Hair',
		            Lookup: angular.copy(_lookupData.FacialHairOptions),
		            ModelPropertyName: 'FacialHairId',
		            DisplayPropertyName: 'Facial Hair',
		            QueryPropName : 'facialHairList',
		            ForGender : 'F'
		        })
		    }
		    return list.concat(list2);
		},
		detailFilterList : function(gender){
			var list =  [{
				Group : 'Basic Information',
				Header: 'Date Of Birth',
				ModelPropertyName: 'DateOfBirth',
				Single: true,
				Type : 'date',
				DisplayPropertyName : 'DateOfBirthD',
				SectionNo : 1
			}, {
				Header: 'Marital Status',
				LookupPropertyName: 'MaritalStatuses',
				ModelPropertyName: 'MaritalStatusId',
				DisplayPropertyName : 'MaritalStatus',
				SectionNo : 1
			}, {
				Header: 'Posted By',
				LookupPropertyName: 'ProfileTypes',
				ModelPropertyName: 'ProfileTypeId',
				DisplayPropertyName : 'ProfileType',
				SectionNo : 1
			}, {
				Header : 'Denomination',
				LookupPropertyName : 'Denominations',
				ModelPropertyName: 'DenominationId',
				HasSubOptions : true,
				SubListLookupProperty : 'DenominationValues',
				SubListModelProperty : 'DenominationValueId',
				SubDisplayPropertyName : 'DenominationValue',
				Group : 'Belief',
				DisplayPropertyName : 'Denomination',
				SectionNo : 2
			},{
				Header : 'Salat',
				LookupPropertyName : 'SalatOptions',
				ModelPropertyName : 'SalatId',
				DisplayPropertyName : 'Salat',
				SectionNo : 2
			},{
				Header : 'Zakat',
				LookupPropertyName : 'ZakatOptions',
				ModelPropertyName : 'ZakatId',
				DisplayPropertyName : 'Zakat',
				SectionNo : 2
			},{
				Header : 'Hajj',
				LookupPropertyName : 'HajjOptions',
				ModelPropertyName : 'HajjId',
				DisplayPropertyName : 'Hajj',
				SectionNo : 2
			},{
				Header : 'Fasting',
				LookupPropertyName : 'FastingOptions',
				ModelPropertyName : 'FastingId',
				DisplayPropertyName : 'Fasting',
				SectionNo : 2
			},{
				Header : 'Country',
				LookupPropertyName : 'Countries',
				ModelPropertyName : 'CountryId',
				Group : 'Location',
				DisplayPropertyName : 'Country',
				SectionNo : 3
			},{
				Header : 'State / Province',
				LookupPropertyName : 'StateProvinces',
				ModelPropertyName : 'StateProvinceId',
				DisplayPropertyName : 'State',
				SectionNo : 3
			},{
				Header : 'Zip',
				//LookupPropertyName : 'Countries',
				ModelPropertyName : 'Zip',
				DisplayPropertyName : 'Zip',
				Single : true,
				Type : 'input',
				SectionNo : 3
			},{
				Header : 'Residency',
				LookupPropertyName : 'ResidencyStatuses',
				ModelPropertyName : 'ResidencyStatusId',
				DisplayPropertyName : 'Residency',
				SectionNo : 3
			},{
				Header : 'Has kids',
				DisplayPropertyName : 'OffspringCurrent',
				LookupPropertyName : 'OffspringOptions',
				ModelPropertyName : 'OffspringCurrentId',
				HasSubOptions : true,
				SubDisplayPropertyName : 'OffspringFuture',
				SubListLookupProperty : 'OffspringFutureOptions',
				SubListModelProperty : 'OffspringFutureId',
				Group : 'OfferSpring',
				SectionNo : 4
			},{
				Header : 'Height',
				LookupPropertyName : 'Heights',
				ModelPropertyName : 'HeightId',
				Group : 'Visual Appearence',
				DisplayPropertyName : 'Height',
				SectionNo : 5
			},{
				Header : 'Body Type',
				LookupPropertyName : 'BodyTypes',
				ModelPropertyName : 'BodyTypeId',
				DisplayPropertyName : 'BodyType',
				SectionNo : 5
			},{
				Header : 'Complexion',
				LookupPropertyName : 'Complexions',
				ModelPropertyName : 'ComplexionId',
				DisplayPropertyName : 'Complextion',
				SectionNo : 5
			},{
				Header : 'Eye Color',
				LookupPropertyName : 'EyeColors',
				ModelPropertyName : 'EyeColorId',
				DisplayPropertyName : 'EyeColor',
				SectionNo : 5
			},{
				Header : 'Hair Color',
				LookupPropertyName : 'HairColors',
				ModelPropertyName : 'HairColorId',
				DisplayPropertyName : 'HairColor',
				SectionNo : 5
			}];

			var list2 = [{
				Header : 'Ethnicity',
				LookupPropertyName : 'Ethnicities',
				ModelPropertyName : 'EthnicityId',
				Group : 'Culture Background',
				DisplayPropertyName : 'Ethnicity',
				SectionNo : 6
			},{
				Header : 'Birth Country',
				LookupPropertyName : 'Countries',
				ModelPropertyName : 'BirthCountryId',
				DisplayPropertyName : 'BirthCountry',
				SectionNo : 6
			},{
				Header : 'First Language',
				LookupPropertyName : 'Languages',
				HasSubOptions : true,
				SubListLookupProperty : 'LanguageProficiencies',
				SubListModelProperty : 'PrimaryLanguageProficiencyId',
				SubDisplayPropertyName : 'PrimaryLanguageProfiencey',
				ModelPropertyName : 'PrimaryLanguageId',
				DisplayPropertyName : 'PrimaryLanguage',
				SectionNo : 6
			},{
				Header : 'Second Language',
				LookupPropertyName : 'Languages',
				ModelPropertyName : 'SecondaryLanguageId',
				HasSubOptions : true,
				SubListLookupProperty : 'LanguageProficiencies',
				SubListModelProperty : 'SecondaryLanguageProficiencyId',
				DisplayPropertyName : 'SecondaryLanguage',
				SubDisplayPropertyName : 'SecondaryLanguageProfiency',
				SectionNo : 6
			},{
				Header : 'Third Language',
				LookupPropertyName : 'Languages',
				ModelPropertyName : 'TertiaryLanguageId',
				HasSubOptions : true,
				SubListLookupProperty : 'LanguageProficiencies',
				SubListModelProperty : 'TertiaryLanguageProficiencyId',
				SubDisplayPropertyName : 'TertiaryLanguageProfiency',
				DisplayPropertyName : 'TertiaryLanguage',
				SectionNo : 6
			},{
				Header : 'Father Status',
				LookupPropertyName : 'ParentStatuses',
				ModelPropertyName : 'FatherStatusId',
				Group : 'Family',
				DisplayPropertyName : 'FatherStatus',
				SectionNo : 7
			},{
				Header : 'Mother Status',
				LookupPropertyName : 'ParentStatuses',
				ModelPropertyName : 'MotherStatusId',
				DisplayPropertyName : 'MotherStatus',
				SectionNo : 7
			},{
				Header : 'Brothers',
				LookupPropertyName : 'SiblingCount',
				ModelPropertyName : 'BrotherCount',
				DisplayPropertyName : 'BrotherCount',
				SectionNo : 7
			},{
				Header : 'Sisters',
				LookupPropertyName : 'SiblingCount',
				ModelPropertyName : 'SisterCount',
				DisplayPropertyName : 'SisterCount',
				SectionNo : 7
			},{
				Header : 'Education Level',
				LookupPropertyName : 'EducationLevels',
				ModelPropertyName : 'EducationLevelId',
				Group : 'Education Carrer',
				DisplayPropertyName : 'EducationLevel',
				SectionNo : 8
			},{
				Header : 'Education Major',
				LookupPropertyName : 'EducationMajors',
				ModelPropertyName : 'EducationMajorId',
				DisplayPropertyName : 'EducationMajor',
				SectionNo : 8
			},{
				Header : 'Annual Income',
				LookupPropertyName : 'AnnualIncomes',
				ModelPropertyName : 'AnnualIncomeId',
				DisplayPropertyName : 'AnnualIncome',
				SectionNo : 8
			},{
				Header : 'Work Type',
				LookupPropertyName : 'WorkTypes',
				ModelPropertyName : 'WorkTypeId',
				DisplayPropertyName : 'WorkType',
				SectionNo : 8
			},{
				Header : 'Career',
				LookupPropertyName : 'Careers',
				ModelPropertyName : 'CareerId',
				DisplayPropertyName : 'Career',
				SectionNo : 8
			},{
				Header : 'Wants partner to work',
				LookupPropertyName : 'PartnerWorkStatusOptions',
				ModelPropertyName : 'PartnerWorkStatusId',
				DisplayPropertyName : 'PartnerWorkStatus',
				SectionNo : 8
			},{
				Header : 'Diet',
				LookupPropertyName : 'Diets',
				ModelPropertyName : 'DietId',
				Group : 'Life Style',
				DisplayPropertyName : 'Diet',
				SectionNo : 9
			},{
				Header : 'Diet Frequency',
				LookupPropertyName : 'DietFrequencyOptions',
				ModelPropertyName : 'DietFrequencyId',
				DisplayPropertyName : 'DietFrequency',
				SectionNo : 9
			},{
				Header : 'Drink (Alchol)',
				LookupPropertyName : 'DrinkingAnswerOptions',
				ModelPropertyName : 'DrinkingAnswerId',
				DisplayPropertyName : 'Drinks',
				SectionNo : 9
			},{
				Header : 'Smokes',
				LookupPropertyName : 'SmokingAnswerOptions',
				ModelPropertyName : 'SmokingAnswerId',
				DisplayPropertyName : 'Smokes',
				SectionNo : 9
			},{
				Header : 'Drugs',
				LookupPropertyName : 'DrugAnswerOptions',
				ModelPropertyName : 'DrugsAnswerId',
				DisplayPropertyName : 'Drugs',
				SectionNo : 9
			},{
				Header : 'Blood Type',
				LookupPropertyName : 'BloodTypes',
				ModelPropertyName : 'BloodTypeId',
				Group : 'Additional Questions',
				DisplayPropertyName : 'BloodType',
				SectionNo : 10
			},{
				Header : 'Special Case',
				LookupPropertyName : 'SpecialCases',
				ModelPropertyName : 'SpecialCaseId',
				Last : true,
				DisplayPropertyName : 'SpecialCase',
				SectionNo : 10
			}];
			if(gender == 'M'){
				list.push({
					Header : 'Facial Hair',
					LookupPropertyName : 'FacialHairOptions',
					ModelPropertyName : 'FacialHairId',
					DisplayPropertyName : 'FacialHair',
					SectionNo : 5,
					ForGender : 'M'
				})
			}else{
				list.push({
					Header : 'Hijab',
					LookupPropertyName : 'HijabOptions',
					ModelPropertyName : 'HijabId',
					DisplayPropertyName : 'Hijab',
					SectionNo : 5,
					ForGender : 'F'
				})
			}
			return list.concat(list2);
		}
	}
})