var GCM_SENDER_ID = '786101787536';
var AZURE_DEVICE_ID = '';

app.factory('pushNotificationService', function ($timeout) {
    return {
        $currentScope: null,
        // Application Constructor
        initialize: function(scope) {
            self = this;
            self.$currentScope = scope;
            self.push = PushNotification.init({
                android: {
                    senderID: GCM_SENDER_ID
                },
                ios: {
                    alert: "true",
                    badge: "true",
                    sound: "true"
                },
                windows: {}
            });
            self.push.setApplicationIconBadgeNumber(function() {}, function() {}, 0);
            self.push.on('registration', function(data){
                var data = { 
                    NativeDeviceId : data.registrationId, 
                    Platform : device.platform,
                    CompanyId : self.$currentScope.CompanyId
                }

                self.$currentScope.ajaxPostPromise("ProfileApi/MobileLogin", data)
                    .then(function(response) {
                        if (response.Success) {
                            AZURE_DEVICE_ID = response.Payload.AzureDeviceId;
                            localStorage.IsPushNotificationEnabled = true;
                            $timeout(function(){
                                self.$currentScope.updatePushNotificationStatus(true);
                            })
                            $timeout
                        }
                        else {
                            alert("Warning: Could not register your device with 'Push Notifications Server'")
                        }
                    })
            })

            self.push.on('notification', function(data) {
                //alert(data.message);
            });

            self.push.on('error', function(e) {
                //alert(e.message)
            });
        },
        unRegister : function(){
            var self = this;
            self.push.unregister(function() {
                var data = { AzureDeviceId : AZURE_DEVICE_ID, Platform : device.platform }
                var url = "ProfileApi/MobileLogout"
                self.$currentScope.ajaxPostPromise(url, data)
            }, function(e) {
                alert("Unregistered Failed")
            })
        }
    }
})