'use strict';
app.factory('tutorialService', function ($ionicModal, $ionicPopup, $state) {
    var tutorialsDir = 'templates/tutorials/';
    return {
        active : null,
        scope : null,
        process : function(baseScope, event, force){
            /*if a popup is already open*/
            this.scope = baseScope;
            if(this.active !== null)
                return false;
            
            if(event == 'dashboard'){
                event = false;
                if(!this.isShown('onDashboardView'))
                    event = 'onDashboardView';
                else if(!this.isShown('uploadCoverImage'))
                    event = 'uploadCoverImage';
                else if(!this.isShown('verifyEmailAddress'))
                    event = 'verifyEmailAddress';
                if(!event){
                    return;
                }
            }

            if(!force && this.isShown(event))
                return false;

            this.show(event);
            this.addShown(event);
            return true;
        },
        show : function(name){
            this.active = $ionicPopup.show({
                templateUrl : this.getPath(name),
                scope: this.scope,
            });
        },
        getPath : function(name){
            return tutorialsDir + name + '.html';
        },
        isShown : function(name){
            var shown = this.getShown();
            return shown.hasOwnProperty(name);

        },
        addShown : function(name){
            var shown = this.getShown();
            shown[name] = name;
            localStorage['tutorials'] = JSON.stringify(shown);
        },
        removeShown : function(name){
            var shown = this.getShown();
            delete shown[name];
            localStorage['tutorials'] = JSON.stringify(shown);
        },
        getShown : function(){
            if(!localStorage['tutorials'])
                return {};
            return JSON.parse(localStorage['tutorials']);
        },
        close : function(state){
            if(this.active){
                this.active.close();
                this.active = null;
            }
            if(state){
                $state.go(state);
            }
        }
    }
});
